#------------------------------------------------------------
# Make the images with varying exposure and pixel scale as per
# the simulation description paper.
#------------------------------------------------------------

nohup idl make_paper_sims.bat &

#------------------------------------------------------------
# Script file for running SExtractor on galaxy and star files
# created by 'simage' pipeline.  Pixel scale runs from 0.05
# to 0.40 arcsecond/pixel.  Exposure time runs from 100 to 
# 400 seconds.  Run script from unix prompt by typing:
# Prompt> sh sex_cat_script.sh
#------------------------------------------------------------

setenv data_dir /scr2/bmd/cleaned_up_simage/shapelet_sims2/DATA/
setenv analysis_dir /scr2/bmd/cleaned_up_simage/shapelet_sims2/analysis/

sex ${home_dir}star_pix01as_exposure_100.000_noisy.fits -c ${analysis_dir}100.sex
mv temp.cat star_pix01as_exposure_100.000_noisy.cat

sex ${home_dir}star_pix01as_exposure_150.000_noisy.fits -c ${analysis_dir}100.sex
mv temp.cat star_pix01as_exposure_150.000_noisy.cat

sex ${home_dir}star_pix01as_exposure_200.000_noisy.fits -c ${analysis_dir}200.sex
mv temp.cat star_pix01as_exposure_200.000_noisy.cat

sex ${home_dir}star_pix01as_exposure_250.000_noisy.fits -c ${analysis_dir}250.sex
mv temp.cat star_pix01as_exposure_250.000_noisy.cat

sex ${home_dir}star_pix01as_exposure_300.000_noisy.fits -c ${analysis_dir}300.sex
mv temp.cat star_pix01as_exposure_300.000_noisy.cat

sex ${home_dir}star_pix01as_exposure_350.000_noisy.fits -c ${analysis_dir}350.sex
mv temp.cat star_pix01as_exposure_350.000_noisy.cat

sex ${home_dir}star_pix01as_exposure_400.000_noisy.fits -c ${analysis_dir}400.sex
mv temp.cat star_pix01as_exposure_400.000_noisy.cat

sex ${home_dir}star_pix01as_exposure_450.000_noisy.fits -c ${analysis_dir}450.sex
mv temp.cat star_pix01as_exposure_450.000_noisy.cat

sex ${home_dir}star_pix01as_exposure_500.000_noisy.fits -c ${analysis_dir}500.sex
mv temp.cat star_pix01as_exposure_500.000_noisy.cat

sex ${home_dir}star_pix01as_exposure_550.000_noisy.fits -c ${analysis_dir}550.sex
mv temp.cat star_pix01as_exposure_550.000_noisy.cat

sex ${home_dir}star_pix01as_exposure_600.000_noisy.fits -c ${analysis_dir}600.sex
mv temp.cat star_pix01as_exposure_600.000_noisy.cat

sex ${home_dir}star_pix01as_exposure_650.000_noisy.fits -c ${analysis_dir}650.sex
mv temp.cat star_pix01as_exposure_650700.000_noisy.cat

sex ${home_dir}star_pix01as_exposure_700.000_noisy.fits -c ${analysis_dir}700.sex
mv temp.cat star_pix01as_exposure_700.000_noisy.cat

sex ${home_dir}star_pix01as_exposure_750.000_noisy.fits -c ${analysis_dir}750.sex
mv temp.cat star_pix01as_exposure_750.000_noisy.cat

sex ${home_dir}star_pix01as_exposure_800.000_noisy.fits -c ${analysis_dir}800.sex
mv temp.cat star_pix01as_exposure_800.000_noisy.cat


#------------------------------------------------------------


sex ${home_dir}galaxy_pix01as_exposure_100.000_noisy.fits -c ${analysis_dir}100.sex
mv temp.cat galaxy_pix01as_exposure_100.000_noisy.cat

sex ${home_dir}galaxy_pix01as_exposure_150.000_noisy.fits -c ${analysis_dir}100.sex
mv temp.cat galaxy_pix01as_exposure_150.000_noisy.cat

sex ${home_dir}galaxy_pix01as_exposure_200.000_noisy.fits -c ${analysis_dir}200.sex
mv temp.cat galaxy_pix01as_exposure_200.000_noisy.cat

sex ${home_dir}galaxy_pix01as_exposure_250.000_noisy.fits -c ${analysis_dir}250.sex
mv temp.cat galaxy_pix01as_exposure_250.000_noisy.cat

sex ${home_dir}galaxy_pix01as_exposure_300.000_noisy.fits -c ${analysis_dir}300.sex
mv temp.cat galaxy_pix01as_exposure_300.000_noisy.cat

sex ${home_dir}galaxy_pix01as_exposure_350.000_noisy.fits -c ${analysis_dir}350.sex
mv temp.cat galaxy_pix01as_exposure_350.000_noisy.cat

sex ${home_dir}galaxy_pix01as_exposure_400.000_noisy.fits -c ${analysis_dir}400.sex
mv temp.cat galaxy_pix01as_exposure_400.000_noisy.cat

sex ${home_dir}galaxy_pix01as_exposure_450.000_noisy.fits -c ${analysis_dir}450.sex
mv temp.cat galaxy_pix01as_exposure_450.000_noisy.cat

sex ${home_dir}galaxy_pix01as_exposure_500.000_noisy.fits -c ${analysis_dir}500.sex
mv temp.cat galaxy_pix01as_exposure_500.000_noisy.cat

sex ${home_dir}galaxy_pix01as_exposure_550.000_noisy.fits -c ${analysis_dir}550.sex
mv temp.cat galaxy_pix01as_exposure_550.000_noisy.cat

sex ${home_dir}galaxy_pix01as_exposure_600.000_noisy.fits -c ${analysis_dir}600.sex
mv temp.cat galaxy_pix01as_exposure_600.000_noisy.cat

sex ${home_dir}galaxy_pix01as_exposure_650.000_noisy.fits -c ${analysis_dir}650.sex
mv temp.cat galaxy_pix01as_exposure_650700.000_noisy.cat

sex ${home_dir}galaxy_pix01as_exposure_700.000_noisy.fits -c ${analysis_dir}700.sex
mv temp.cat galaxy_pix01as_exposure_700.000_noisy.cat

sex ${home_dir}galaxy_pix01as_exposure_750.000_noisy.fits -c ${analysis_dir}750.sex
mv temp.cat galaxy_pix01as_exposure_750.000_noisy.cat

sex ${home_dir}galaxy_pix01as_exposure_800.000_noisy.fits -c ${analysis_dir}800.sex
mv temp.cat galaxy_pix01as_exposure_800.000_noisy.cat


#------------------------------------------------------------


sex ${home_dir}star_exp400s_pixelscale_0.0500000_noisy.fits -c ${analysis_dir}0050.sex
mv temp.cat star_exp400s_pixelscale_0.0500000_noisy.cat

sex ${home_dir}star_exp400s_pixelscale_0.0750000_noisy.fits -c ${analysis_dir}0075.sex
mv temp.cat star_exp400s_pixelscale_0.0750000_noisy.cat

sex ${home_dir}star_exp400s_pixelscale_0.100000_noisy.fits -c ${analysis_dir}0100.sex
mv temp.cat star_exp400s_pixelscale_0.100000_noisy.cat

sex ${home_dir}star_exp400s_pixelscale_0.125000_noisy.fits -c ${analysis_dir}0125.sex
mv temp.cat star_exp400s_pixelscale_0.125000_noisy.cat

sex ${home_dir}star_exp400s_pixelscale_0.150000_noisy.fits -c ${analysis_dir}0150.sex
mv temp.cat star_exp400s_pixelscale_0.150000_noisy.cat

sex ${home_dir}star_exp400s_pixelscale_0.175000_noisy.fits -c ${analysis_dir}0175.sex
mv temp.cat star_exp400s_pixelscale_0.175000_noisy.cat

sex ${home_dir}star_exp400s_pixelscale_0.200000_noisy.fits -c ${analysis_dir}0200.sex
mv temp.cat star_exp400s_pixelscale_0.200000_noisy.cat

sex ${home_dir}star_exp400s_pixelscale_0.225000_noisy.fits -c ${analysis_dir}0225.sex
mv temp.cat star_exp400s_pixelscale_0.225000_noisy.cat

sex ${home_dir}star_exp400s_pixelscale_0.250000_noisy.fits -c ${analysis_dir}0250.sex
mv temp.cat star_exp400s_pixelscale_0.250000_noisy.cat

sex ${home_dir}star_exp400s_pixelscale_0.275000_noisy.fits -c ${analysis_dir}0275.sex
mv temp.cat star_exp400s_pixelscale_0.275000_noisy.cat

sex ${home_dir}star_exp400s_pixelscale_0.300000_noisy.fits -c ${analysis_dir}0300.sex
mv temp.cat star_exp400s_pixelscale_0.300000_noisy.cat

sex ${home_dir}star_exp400s_pixelscale_0.325000_noisy.fits -c ${analysis_dir}0325.sex
mv temp.cat star_exp400s_pixelscale_0.325000_noisy.cat

sex ${home_dir}star_exp400s_pixelscale_0.350000_noisy.fits -c ${analysis_dir}0350.sex
mv temp.cat star_exp400s_pixelscale_0.350000_noisy.cat

sex ${home_dir}star_exp400s_pixelscale_0.375000_noisy.fits -c ${analysis_dir}0375.sex
mv temp.cat star_exp400s_pixelscale_0.375000_noisy.cat

sex ${home_dir}star_exp400s_pixelscale_0.400000_noisy.fits -c ${analysis_dir}0400.sex
mv temp.cat star_exp400s_pixelscale_0.400000_noisy.cat


#------------------------------------------------------------


sex ${home_dir}galaxy_exp400s_pixelscale_0.0500000_noisy.fits -c ${analysis_dir}0050.sex
mv temp.cat galaxy_exp400s_pixelscale_0.0500000_noisy.cat

sex ${home_dir}galaxy_exp400s_pixelscale_0.0750000_noisy.fits -c ${analysis_dir}0075.sex
mv temp.cat galaxy_exp400s_pixelscale_0.0750000_noisy.cat

sex ${home_dir}galaxy_exp400s_pixelscale_0.100000_noisy.fits -c ${analysis_dir}0100.sex
mv temp.cat galaxy_exp400s_pixelscale_0.100000_noisy.cat

sex ${home_dir}galaxy_exp400s_pixelscale_0.125000_noisy.fits -c ${analysis_dir}0125.sex
mv temp.cat galaxy_exp400s_pixelscale_0.125000_noisy.cat

sex ${home_dir}galaxy_exp400s_pixelscale_0.150000_noisy.fits -c ${analysis_dir}0150.sex
mv temp.cat galaxy_exp400s_pixelscale_0.150000_noisy.cat

sex ${home_dir}galaxy_exp400s_pixelscale_0.175000_noisy.fits -c ${analysis_dir}0175.sex
mv temp.cat galaxy_exp400s_pixelscale_0.175000_noisy.cat

sex ${home_dir}galaxy_exp400s_pixelscale_0.200000_noisy.fits -c ${analysis_dir}0200.sex
mv temp.cat galaxy_exp400s_pixelscale_0.200000_noisy.cat

sex ${home_dir}galaxy_exp400s_pixelscale_0.225000_noisy.fits -c ${analysis_dir}0225.sex
mv temp.cat galaxy_exp400s_pixelscale_0.225000_noisy.cat

sex ${home_dir}galaxy_exp400s_pixelscale_0.250000_noisy.fits -c ${analysis_dir}0250.sex
mv temp.cat galaxy_exp400s_pixelscale_0.250000_noisy.cat

sex ${home_dir}galaxy_exp400s_pixelscale_0.275000_noisy.fits -c ${analysis_dir}0275.sex
mv temp.cat galaxy_exp400s_pixelscale_0.275000_noisy.cat

sex ${home_dir}galaxy_exp400s_pixelscale_0.300000_noisy.fits -c ${analysis_dir}0300.sex
mv temp.cat galaxy_exp400s_pixelscale_0.300000_noisy.cat

sex ${home_dir}galaxy_exp400s_pixelscale_0.325000_noisy.fits -c ${analysis_dir}0325.sex
mv temp.cat galaxy_exp400s_pixelscale_0.325000_noisy.cat

sex ${home_dir}galaxy_exp400s_pixelscale_0.350000_noisy.fits -c ${analysis_dir}0350.sex
mv temp.cat galaxy_exp400s_pixelscale_0.350000_noisy.cat

sex ${home_dir}galaxy_exp400s_pixelscale_0.375000_noisy.fits -c ${analysis_dir}0375.sex
mv temp.cat galaxy_exp400s_pixelscale_0.375000_noisy.cat

sex ${home_dir}galaxy_exp400s_pixelscale_0.400000_noisy.fits -c ${analysis_dir}0400.sex
mv temp.cat galaxy_exp400s_pixelscale_0.400000_noisy.cat

#------------------------------------------------------------
# Analyse the images and produce plots
#------------------------------------------------------------

nohup idl rrg.bat &

#------------------------------------------------------------
# end
#------------------------------------------------------------
