pro simage_plt_postage

!p.multi=0

file = 'example'
obj = 0L
input_gamma = [0., 0.]
inst_shear = [0., 0.]

f_in=dblarr(13)
e1_in=dblarr(13)
e2_in=dblarr(13)
xc_in=dblarr(2,13)
r_in=dblarr(13)

f=dblarr(13)
e1=dblarr(13)
e2=dblarr(13)
xc=dblarr(2,13)
r=dblarr(13)

px=indgen(13)*0.01+0.04

;
;
; Get the color range.
;
;

decomp = simage_shapecat2postage( $
                      file = file, $
                      obj = obj, $
                      psf = 0B, $
                      pixel_scale = 0.09, $
                      const_psf_size = 0B $
                     )
simage_shapelets_recomp,decomp,im
im=im/0.09^2
cran=[ min(im), max(im) ]



psf = 0B
const_psf_size = 1B
ops, file="spiral_nopsf_orig.ps", bits=5
decomp = simage_shapecat2postage( $
                          n_pixels=390, $
                          file = file, $
                          obj = obj, $
                          psf = psf, $
                          pixel_scale = 0.004, $
                          const_psf_size = const_psf_size $
                         )
simage_shapelets_recomp,decomp,im
    
print, "flux=", total(im)
im=im/0.004^2
simage_plt_image, im, /scal, cran=cran
cps

psf = 0B
const_psf_size = 1B
ops, file="spiral_nopsf.ps", bits=5
i=0
for pixel_scale = 0.04, 0.16, 0.01 do begin

    print, "Getting object number ", obj, " from shapecat ", file, " at pixel scale ", pixel_scale
    
    decomp = simage_shapecat2postage( $
                          file = file, $
                          obj = obj, $
                          psf = psf, $
                          pixel_scale = pixel_scale, $
                          const_psf_size = const_psf_size $
                         )
    simage_shapelets_recomp,decomp,im
;    shapelets_decomp,im,decomp.beta,2,decomp2,x0
    
    simage_shapelets_moments,decomp,dmom,/printit
    help,dmom,/struct
    f_in[i]=dmom.f
    e1_in[i]=dmom.e1
    e2_in[i]=dmom.e2
    xc_in[*,i]=dmom.xc*pixel_scale
    r_in[i]=dmom.r*pixel_scale

    mom=simage_shapelets_image_moments(im,/printit)
    help,mom,/st
    f[i]=mom.f
    e1[i]=mom.e1
    e2[i]=mom.e2
    xc[*,i]=mom.xc*pixel_scale
    r[i]=mom.r*pixel_scale
    

    print, "flux=", total(im)
    im=im/pixel_scale^2

    simage_plt_image, im, /scal, cran=cran
   
    i++
endfor
cps

print,xc
print,xc_in

set_plot, 'ps'
device,filename='spiral_plots.ps',yoffset=10,ysize=35.,xsize=17.,encapsul=encap,$
       color=color,bits_per_pixel=bits_per_pixel
!p.charsize=1.5

!p.multi=[6,1,6]
plot,px,f,psym=4,yrange=[1.015,1.025],ytitle='!6intensity (photons/sec)'
oplot,[-1,1]*1000,[1,1]*f_in,line=1

plot,px,xc[0,*]-xc_in[0,*],psym=4,yrange=[-1,1]*0.001,ytitle='!6x location (arcsec)'
oplot,[-1,1]*1000,[0,0]*xc_in[0],line=1

plot,px,xc[1,*]-xc_in[1,*],psym=4,yrange=[-1,1]*0.001,ytitle='!6y location (arcsec)'
oplot,[-1,1]*1000,[0,0]*xc_in[1],line=1

plot,px,r,psym=4, yrange=[0.19,0.21],ytitle='!6rms radius (arcsec)'
oplot,[-1,1]*1000,[1,1]*r_in,line=1

plot,px,e1,psym=4, yrange=[-0.04,-0.02], ytitle='!6e1'
oplot,[-1,1]*1000,[1,1]*e1_in,line=1

plot,px,e2,psym=4,yrange=[-0.06,-0.04],ytitle='!6e2', xtitle='!6pixel scale (arcsec/pixel)'
oplot,[-1,1]*1000,[1,1]*e2_in,line=1
cps

end

psf = 1B
const_psf_size = 1B
ops, file="spiral_constpsf.ps", bits=5
for pixel_scale = 0.04, 0.16, 0.01 do begin

    print, "Getting object number ", obj, " from shapecat ", file, " at pixel scale ", pixel_scale
    
    decomp = simage_shapecat2postage( $
                          file = file, $
                          obj = obj, $
                          psf = psf, $
                          pixel_scale = pixel_scale, $
                          const_psf_size = const_psf_size $
                         )
    simage_shapelets_recomp,decomp,im
    
    print, "flux=", total(im)

    simage_plt_image, im, /scal, cran=cran
        
endfor
cps

psf = 1B
const_psf_size = 0B
ops, file="spiral_snappsf.ps", bits=5
for pixel_scale = 0.04, 0.16, 0.01 do begin

    print, "Getting object number ", obj, " from shapecat ", file, " at pixel scale ", pixel_scale
    
    decomp = simage_shapecat2postage( $
                          file = file, $
                          obj = obj, $
                          psf = psf, $
                          pixel_scale = pixel_scale, $
                          const_psf_size = const_psf_size $
                         )
    simage_shapelets_recomp,decomp,im
    
    print, "flux=", total(im)

    simage_plt_image, im, /scal, cran=cran
        
endfor
cps

end
