pro simage_check_udf_density

rdir='/scr2/rhodes/davej/SNAP_sim/'

realdir=rdir+'realUDF/'
;simdir=rdir+'simUDF/'
simdir='/scr/davej/data/simUDF/'
snapdir='/scr/davej/data/SNAP/'

z= [25.6730   ,   26.4860  ,    25.6540   ,   24.8620   ,   23.4034   ,   23.2146]

b1=24.0
b2=26.0

;area1=1.0
area2=11.49
area3=11.49


x0=2825
x1=7725

y0=3037
y1=7402
pscale=0.03

dx=(x1-x0)*pscale/60.0
dy=(y1-y0)*pscale/60.0

area1=dx*dy

print,'area 1 ',area1
print,'area 2 ',area2

;band = ['b','v','i','z','j','h']
band = ['b','v','i','z']

nb=n_elements(band)

;f='_simUDF_Mar14_noisy.fits'
f='_simUDF_Mar17_noisy.fits'

g1='h_udf_wfc_'
g2='_drz_img.fits'

if 0 then begin
    for i=0, nb-1 do begin
        file=realdir+g1+band[i]+g2
        im=mrdfits(file,0,hdr)
        ims=im[x0:x1,y0:y1]
        tvim2,ims
        file2=realdir+band[i]+'_small.fits'
        writefits,file2,ims,hdr
    endfor
endif

mbin=0.2
mag_min=22.0
mag_max=31.0
magr=(mag_max-mag_min)
n=long(magr/mbin)
mbin=magr/n

hx=findgen(n)/(n)*magr+mag_min+mbin/2.0

print,'Mag bin ',mbin

for i=0, nb-1 do begin
    cfile=realdir+band[i]+'_small_cat.fits'
    cat=mrdfits(cfile,1)
    mag=z[i]+cat.mag_auto
    w=where(mag ge mag_min and mag lt mag_max)
    junk1=where(mag ge b1 and mag le b2,c1)
    c1=c1/area1
    c1err=sqrt(c1)/area1
    m=(mag[w]-mag_min)/mbin
    hy=histogram(m,min=0,max=n)
    hy=hy/area1
    ;plothist,mag,bin=0.1,ax,ay

    cfile2=simdir+band[i]+'_simUDF_Mar17_noisy_cat.fits'
    imfile2=simdir+band[i]+'_simUDF_Mar17_noisy.fits'
    h=headfits(imfile2)
    z2=sxpar(h,'PHOTOZP')
    print,'zeropoint ',z2
    cat2=mrdfits(cfile2,1,hh)
    mag2=z[i]+cat2.mag_auto
    junk2=where(mag2 ge b1 and mag2 le b2,c2)
    c2=c2/area2
    c2err=sqrt(c2)/area2
    
    cfile3=snapdir+band[i]+'_SNAP_Mar17_2000_noisy_cat.fits'
    imfile3=snapdir+band[i]+'_SNAP_Mar17_2000_noisy.fits'
    h=headfits(imfile3)
    z3=sxpar(h,'PHOTOZP')
    print,'zeropoint ',z3
    cat3=mrdfits(cfile3,1,hh)
    mag3=z3+cat3.mag_auto
    junk3=where(mag3 ge b1 and mag3 le b2,c3)
    c3=c3/area3
    c3err=sqrt(c3)/area3


    relerr=sqrt(1.0/n_elements(junk1) + 1.0/n_elements(junk2))

    rat=c2/c1
    raterr=rat*relerr
    
    print,'Ratio ',rat, ' +/- ',raterr

    w2=where(mag2 ge mag_min and mag2 lt mag_max)
    m2=(mag2[w2]-mag_min)/mbin
    hy2=histogram(m2,min=0,max=n)
    hy2=hy2/area2
    
    w3=where(mag3 ge mag_min and mag3 lt mag_max)
    m3=(mag3[w3]-mag_min)/mbin
    hy3=histogram(m3,min=0,max=n)
    hy3=hy3/area3

    

    str=band[i]+'  '+strmid(strcompress(rat,/rem),0,5)+' '+!csym.plusminus+' '+strmid(strcompress(raterr,/rem),0,5)
    
    plot,hx,hy,psym=10,tit=str,/ylog,yr=[0.5,max(hy)*1.5],/yst,$
         xr=[mag_min,mag_max],/xst,xtit='Mag_auto',ytit='Num / Arcmin !E2!N'
    
    xyouts,28,2,'real',/data,charsize=1.5
    xyouts,28,2/1.5,'sim',/data,charsize=1.5,color=!red
    xyouts,28,2/1.5/1.5,'snap',/data,charsize=1.5,color=!blue
    oplot,[1,1]*b1,[.01,100],color=!green,linest=2
    oplot,[1,1]*b2,[.01,100],color=!green,linest=2
    oplot,hx,hy2,color=!red,psym=10
    oplot,hx,hy3,color=!blue,psym=10


    if 0 then begin
        print,'ok?'
        key=get_kbrd(20)
        if key eq 's' then stop
        if key eq 'q' then retun
    endif
endfor



return
end

