pro simage_check_udf_skynoise,sky

!p.multi=[0,2,2]
sky_level = [24.,52.3,34.7,24.1,133.0,141.9]
pixsize=[0.03,0.03,0.03,0.03,0.09,0.09]
exposure_time = [134880.,135320.,347110.,346620.,196730.,209849.]
zpt=[25.673,26.486,25.654,24.862,23.4034,23.2146]

dir='/scr/davej/data/UDF_images/'

files=dir+['h_udf_wfc_b_drz_img.fits','h_udf_wfc_v_drz_img.fits','h_udf_wfc_i_drz_img.fits','h_udf_wfc_z_drz_img.fits']
nfiles=n_elements(files)

sigma=fltarr(nfiles)
gary_mag_sigma=sigma
sky=sigma

for i=0, nfiles-1 do begin
    im=mrdfits(files[i],0,hdr)
    ims=im[4000:5000,4000:5000]
    simage_sky_noise,ims,m,sig,/plot
    sigma[i]=sig
    sky[i]=sig^2*exposure_time[i]/(pixsize[i]^2)
    ;sky is in counts/sec/arcsec
    gary_mag_sigma[i]=zpt[i]-2.5*alog10(sigma[i]/(pixsize[i]))
endfor

mag_sky=zpt[0:nfiles-1]-2.5*alog10(sky)

print,'sigma ',sigma
print,'sky ',sky
print,'sky_matt ' ,sky_level
print,'mag_sky ',mag_sky
print,'gary_mag_sigma ',gary_mag_sigma

stop

return
end
