pro simage_determine_width,psf,sig,yslice=yslice,xslize=xslice,buf=buf
;make a rought estimation of the width of a PSF
;that is the best fit Gaussian

if n_elements(buf) eq 0 then buf=6

doplot=0
if doplot then !p.multi=[0,2,2]

s=size(psf,/dim)
nx=s[0]
ny=s[1]

;do the x slice or y?
if keyword_set(yslice) then begin
    y=reform(psf[nx/2,*])
    nx=ny
endif else begin
    ;the default
    y=reform(psf[*,nx/2])
endelse

x=findgen(nx)

xx=x[nx/2-buf:nx/2+buf]
yy=y[nx/2-buf:nx/2+buf]
lyy=alog(yy)

p=reform(poly_fit(xx,lyy,2,yfit))

if doplot then begin
    plot,x,y,psym=-1,xr=[nx/2-2*buf,nx/2+2*buf]
    oplot,xx,yy,psym=7,color=!red
endif

if doplot then begin
    plot,xx,lyy,psym=-1,/yno
    oplot,xx,yfit,color=!red,psym=7
endif

sig2=-0.5/p[2]

if sig2 lt 0 then begin
    print,'ERROR - not concave down'
    sig=-999.0
    return
endif

sig=sqrt(sig2)
m=-p[1]/(2*p[2])
u=((xx-m)/sig)^2
g=exp(-0.5*u)

if doplot then begin
    plot,xx,yy,psym=-1
    oplot,xx,g*max(yy),psym=-7,color=!green
endif

return
end

