pro simage_draw_mag_exponential,m_min,m_max,mag,A=A,B=B,sky_area=sky_area,Num=Num,seed=seed
;draw from the density, that is number per square degree per magnitude
;N(m) = B 10^(Am)
;Uses Leathaud et al function Num=B*10^(A*mag)
;between mag 21 and 26 
;below 21 and above 26, this is truncated to agree better with
;data in Metcalf et al.

;the defaults from COSMOS , Leautheau et al. 2007
;calibrated from 21-26 magnitude
if n_elements(A) eq 0 then A=0.332
if n_elements(B) eq 0 then B=0.000572836
if n_elements(sky_area) eq 0 then sky_area=1.0

truncate=1

aa=A*alog(10)

always=1
if n_elements(Num) eq 0 or always then begin
   area_deg=sky_area/3600.0         ;convert arcmin^2 to deg^2
   Num=round((area_deg*B/aa)*(exp(aa*m_max)-exp(aa*m_min)))
endif

u_max=exp(aa*m_max)/aa
u_min=exp(aa*m_min)/aa

u=randomu(seed,Num)*(u_max-u_min)+u_min
mag=alog(aa*u)/aa


if keyword_set(truncate) then begin
   frac=simage_num_counts_frac(mag)
   wkeep=where(randomu(seed,Num) lt frac,nkeep)
   Num=nkeep
   mag=mag[wkeep]
endif

print,'Determined Number of input galaxies = ',Num,' in sky area = ',sky_area,' arcmin^2'


return
end
