pro simage_generate_simage

message, "Beginning", /info

; Determine input parameters.
@simage_parameters
message, "Done getting telescope params",/info

; Make the conv kernel based on the input PSF.
if keyword_set(psf) then $
  simage_make_conv,psf,telescope=0B,run=run,dir=outdir

; Create a noise-free simulated image.
output_file = outdir+'/'+output_file ; Fullpaths now!
simage_assemble_image,shapecat,output_file,n_pix=n_pixels,seed=random_seed,$
  n_gal=n_gal,n_star=n_star,psf=psf,gamma_input=input_gamma,$
  sigmae=sigma_epsilon,param=object_type,dither=dither_offset,$
  pixsize=pixel_scale,image=image,header=header,rpos=random_positions,$
  /fullpath,noise_only=noise_only

;scale_noise=1B

; Add background noise model.
simage_add_noise,output_file,           $
  filename_output   = output_file+"_noisy", $
  /weight_map, $
  exposure_time     = exposure_time,    $  
  throughput        = throughput,       $
  seed              = noise_seed,       $
;  header            = header,           $
  /update,                              $
  background        = background,       $     
;  shot_noise        = shot_noise,       $     
;  gauss_noise       = gauss_noise,      $    
;  gain              = gain,             $        
;  sat_level         = sat_level,        $       
;  read_noise        = read_noise,       $       
;  DQE               = DQE,              $        
;  bias              = bias,             $        
;  hdf_time          = hdf_time,         $       
  CCDwidth          = CCDwidth,         $      
  CCDthickness      = CCDthickness,     $    
  CRdiffusion       = CRdiffusion,      $    
  CRflux            = CRflux,           $        
  CRn_elec          = CRn_elec,         $        
  CRsigma           = CRsigma,          $         
;  scale_noise       = scale_noise,      $
;  sky_smooth            = sky_smooth,           $         
;  sky_kernel            = sky_kernel,           $         
  positive_definite = positive_definite,$
  hide_shear        = hide_shear,       $
  /full_path

; Run SExtractor on the noisy simulated image.
orig_ofile=output_file
output_file=output_file+"_noisy" ; Now done in add_noise
sex,output_file,telescope=telescope,$
  pixel_scale=pixel_scale,run=run,$
  /fullpath

; cmd='gzip -vf '+orig_ofile+'*.fits'
; print,cmd
; spawn,cmd

; Quit IDL, returning a successful flag.
message,'Done',/info

end
