pro simage_get_dune_psf,psf,pix_scale=pix_scale,mirror_size=mirror_size, psf_name=psf_name
;read the dune psf
;pix_scale , the pixel scale, default is 0.115
;mirror_size, The mirror diameter in m, the default is 1.2

if n_params() eq 0 then begin
    print,'-syntax simage_get_dune_psf,psf,pix_scale=pix_scale,mirror_size=mirror_size'
    return
endif

n_max=8

diff_length = 0.00296296        ;any small number

print, 'psf_name = ', psf_name

simage_shapelets_read_psf,psf,thispsf=simage_shapelets_paths(4,/silent)+psf_name,$
  pixsize=pix_scale,mirror_factor=mirror_size/0.57,$
  diff_length=diff_length,n_max=n_max

;normalize it
psf_tot=simage_shapelets_flux(psf)
psf.coeffs=psf.coeffs/psf_tot
psf.coeffs_error=psf.coeffs_error/psf_tot

return
end

