pro simage_get_metcalf_nc,mag,num

file="~/Metcalf_gal_number_counts.png"
outfile="~/metcalf_nc.dat"

if file_test(outfile) eq 0 then begin
   
   read_png,file,im
   
   im=reform(im[1,*,*])
   
   tvim2,im
   
   xr=[14,29]
   yr=[1,1e8]
   
   print,"xr=",xr
   print,"yr=",yr
   
   yr=alog10(yr)
   simage_steal_data,im,x,y,err,xr=xr,yr=yr
   
   
   mag=x
   num=10.0^(y)*2.0             ;num per deg^2 per mag
   
                                ;write to file
   
   n=n_elements(mag)
   
   
   get_lun,unit
   openw,unit,outfile
   
   for i=0, n-1 do begin
      printf,unit,mag[i],num[i]
   endfor
   
   free_lun,unit
endif else begin
   readcol,outfile,mag,num
endelse   

slope_nc=0.332                  ;Frome Leauthaud et al , COSMOS
amp_nc=0.000572836              

mag_off=0.37

m=mag+mag_off
mag=0
plot,m,num,psym=-7,/ylog

oplot,m,amp_nc*10.0^(m*slope_nc),color=!red
;w=where(m gt 21 and m lt 26)
;oplot,m[w],amp_nc*10.0^(m[w]*slope_nc),color=!blue,psym=-1
oplot,[1,1]*21,[1e-9,1e11],linest=2
oplot,[1,1]*26,[1e-9,1e11],linest=2


lnum=alog10(num)

p=poly_fit(m,lnum,4)

yfit=poly(m,p)
;oplot,m,10.0^(yfit),color=!green

m1=21
m2=26

w1=where(m lt m1+1)

l1=alog10(amp_nc)+slope_nc*m1

xx=m+m1
zz=(lnum-l1)/(m-m1)

line=linfit(xx[w1],zz[w1])
a1=line[1]
b1=line[0]

print,a1,b1

oplot,m[w1],10.0^(a1*(m[w1]^2-m1^2)+b1*(m[w1]-m1)+l1),color=!magenta

w2=where(m gt m2-1)

l2=alog10(amp_nc)+slope_nc*m2

xx=m+m2
zz=(lnum-l2)/(m-m2)

line=linfit(xx[w2],zz[w2])
a2=line[1]
b2=line[0]

print,a2,b2

oplot,m[w2],10.0^(a2*(m[w2]^2-m2^2)+b2*(m[w2]-m2)+l2),color=!magenta




return
end
