pro simage_get_shapelet_objects,catalog,objlist,adjust_factor,m_min=m_min,m_max=m_max,A=A,B=B,Num=Num,seed=seed,sky_area=sky_area

if n_params() eq 0 then begin
   print,'-syntax simage_get_shapelet_objects,catalog,objlist,adjust_factor,m_min=m_min,m_max=m_max,A=A,B=B,Num=Num,seed=seed'
   return
endif

band=2                           ;always use this since it is COSMOS           

if n_elements(m_min) eq 0 then m_min=19.0
if n_elements(m_max) eq 0 then m_max=29.0
if n_elements(catalog) eq 0 then begin
   path = simage_shapelets_paths(3,/silent)
   restore,path+'shapecat_total_trim.sav'
   catalog=NEW_SHAPECAT[band]
endif

simage_draw_mag_exponential,m_min,m_max,mag,A=A,B=B,Num=Num,sky_area=sky_area,seed=seed

cat_mag=catalog.sexmag
s=sort(cat_mag)
us=sort(s)
cat_mag_sort=cat_mag[s]

objlist=lonarr(Num)
adjust_factor=fltarr(Num)       ;multiple the shapelet object by this to get
                                ;the magnitude exactly right

num_max=n_elements(cat_mag)
;find the closest objects in magnitude
for i=0L, Num-1 do begin
   simage_binary_search,cat_mag_sort,mag[i],index
   if index eq -1 or index eq num_max-1 then begin
      print,'magnitude is out of range'
      print,'this should not happen, Call Dave'
      stop
   endif

   if abs(cat_mag_sort[index]-mag[i]) gt abs(cat_mag_sort[index+1]-mag[i]) then index=index+1

   index=s[index]             
   ;index=index>1                 ;;don't allow zero for some reason
   objlist[i]=index
   
   mag_desired=mag[i]
   mag_actual=cat_mag[index]
   
   adj=10.0^((mag_actual-mag_desired)/2.5)
   if abs(adj-1) gt 2 then begin
      print,"Holy adjustflux Batman!, ",adj
      stop
   endif
   adjust_factor[i]=adj

   if 0 then begin
      print,'desired', mag[i]
      print,'actual ',cat_mag[index],' index=',index
      print,adjust_factor[i]
      print
   endif

endfor

if 0 then begin
   plothist,mag,bin=.01
   plothist,cat_mag[objlist],color=!green,/ov,bin=0.01
   plothist,mag,bin=.01,/ov
endif

return
end



