pro simage_get_snap_psf,psf,ee50,plot=plot, psf_name=psf_name

if n_params() eq 0 then begin
    print,'-syntax get_snap_psf,psf,ee50'
    return
endif

if n_elements(ee50) eq 0 then begin
    ;ee50=1.555
    ee50=2.1
    print,'Using nominal value for EE50 ',EE50
endif else begin
    print,'Using input value for EE50 ',EE50
endelse

drizzle_fac=2.0

psize_mic=10.0/drizzle_fac
pixsize=0.05                    ;don't change

print,'Reading SNAP PSF'

defsysv,'!SNAP_RAW_PSF',ex=ex

if ex eq 0 then begin
    print,'Reading PSF'
    simage_shapelets_read_psf,psf_raw,thispsf=simage_shapelets_paths(4,/silent)+psf_name,$
                     pixsize=pixsize,lambda=lambda,diff_length=4.0*(10.0/psize_mic)    
    defsysv,'!SNAP_RAW_PSF',psf_raw
    print,'Catcheing raw PSF' 
endif else begin
    print,'Using Cached raw PSF'
    psf_raw=!SNAP_RAW_PSF
endelse

psf=psf_raw

fac=1.292330                     ;adjust to match Gary's nominal value

;ee50_nom=1.555
ee50_nom=2.1

psf.beta=psf.beta*fac*(ee50/ee50_nom)

simage_get_ee50,psf,ee50_out,plot=plot,/pix

print,'EE50  desired ',ee50,' pixels'
print,'EE50  obtained',ee50_out,' pixels'

dif=(ee50/ee50_out-1)*100.0

print,' Difference = ',dif,' %'

;normalize it
psf_tot=simage_shapelets_flux(psf)
psf.coeffs=psf.coeffs/psf_tot
psf.coeffs_error=psf.coeffs_error/psf_tot

return
end
