pro simage_make_color_images,snap=snap,udf=udf,simudf=simudf,dune=dune,file=file

if keyword_set(snap) then type = 'snap'
if keyword_set(dune) then type = 'dune'
if keyword_set(udf) then type = 'udf'
if keyword_set(simudf) then type = 'simudf'

band=['b','v','i','z','j','h']

if type eq 'snap' then begin
    dir='/scr/davej/data/SNAP/'
    f=file_search(dir+band+'_SNAP_Mar17_2000_noisy.fits')
    im_b=(mrdfits(f[0]) + mrdfits(f[1]))/2.0  
    im_g=mrdfits(f[2])
    im_r=mrdfits(f[3])
endif

if type eq 'simudf' then begin
    dir='/scr/davej/data/simUDF/'
    f=file_search(dir+band+'_simUDF_Mar17_noisy.fits')
    im_b=(mrdfits(f[0]) + mrdfits(f[1]))/2.0
    im_g=mrdfits(f[2])
    im_r=mrdfits(f[3])
endif


if type eq 'udf' then begin

    ;keep this range
    if 1 then begin
        x0=2825
        x1=7725
        y0=3037
        y1=7402
    endif else begin
        ;smaller
        print,'smaller version'
        x0=4000
        x1=5000
        y0=4000
        y1=5000
    endelse

    dir='/scr2/rhodes/davej/SNAP_sim/realUDF/'
    p1='h_udf_wfc_'
    p2='_drz_img.fits'
    f=file_search(dir+p1+band+p2)
    im_b=(mrdfits(f[0]) + mrdfits(f[1]))/2.0
    im_b=im_b[x0:x1,y0:y1]
    im_g=mrdfits(f[2])
    im_g=im_g[x0:x1,y0:y1]
    im_r=mrdfits(f[3])
    im_r=im_r[x0:x1,y0:y1]
endif

color_im_log,im_r,im_g,im_b,weight=[1.0,1.0,1.0]

if n_elements(file) ne 0 then begin
    saveimage,file,/png
endif

return
end

