pro simage_make_filename, output_file, $
  pixel_scale     = pixel_scale, $
  input_catalogue = input_catalogue, $
  input_gamma     = input_gamma, $
  run             = run, $
  stellar         = stellar, $
  exposure_time   = exposure_time, $
  spaces          = spaces

if n_params() eq 0 then message, "simage_make_filename, output_file=output_file, pixel_scale=pixel_scale, input_catalogue=input_catalogue, input_gamma=input_gamma"

sep = '_'
if keyword_set(spaces) then sep = ' '

; Now make the filename.
if keyword_set(pixel_scale) then begin
    output_file = output_file + sep + "p" + strmid(strtrim(pixel_scale,2),0,5)
endif
if keyword_set(input_catalogue) then begin
    output_file = output_file + sep + "v" + strtrim(input_catalogue,2)
endif
if keyword_set(input_gamma) then begin
    if (input_gamma[0] lt 0) then g0_sign = '-' else g0_sign = '+'
    if (input_gamma[1] lt 0) then g1_sign = '-' else g1_sign = '+'
    g0_string = g0_sign + strmid(strtrim(abs(double(input_gamma[0])),2),0,5)
    g1_string = g1_sign + strmid(strtrim(abs(double(input_gamma[1])),2),0,5)
;    if keyword_set(spaces) then begin
;        output_file = output_file + $
;                      sep + "!cs" + g0_string + $
;                      sep + g1_string
;    endif else begin
    output_file = output_file + $
                  sep + "s" + g0_string + $
                  sep + g1_string
;    endelse
endif
if keyword_set(run) then begin
    output_file = output_file + sep + run
endif
if keyword_set(stellar) then begin
    output_file = output_file + sep + "star"
endif
if keyword_set(exposure_time) then begin
    output_file = output_file + sep + "t" + strmid(strtrim(exposure_time,1),0,5)
endif

;output_file = output_file + $
;              "_p" + strmid(strtrim(pixel_scale,2),0,5) + $
;              "_v" + strtrim(input_catalogue,2) + $
;              "_s" + strmid(strtrim(input_gamma[0],2),0,5) + $
;              "_"  + strmid(strtrim(input_gamma[1],2),0,5)
; Exposure_time is set somewhere in the middle of the simage generation.

end
