pro simage_make_snap_psf

outfile=simage_shapelets_paths(4,/silent)+'PSF/fits/snap_psf_tmp.fits'
rad=40.0                      
;truncate it after this  
trim=40                         ;trim off this bit

thispsf=simage_shapelets_paths(4,/silent)+'PSF/fits/rhodes_11.fits'

im=exp(mrdfits(thispsf,0,hdr))

help,im
print
print,hdr

s=size(im,/dim)
nx=s[0]
ny=s[1]

plot,im[*,ny/2]

l=lindgen(nx*ny)
x=reform(float((l mod nx)-nx/2),nx,ny)
y=reform(float((l/nx) -ny/2),nx,ny)
r=sqrt(x^2+y^2)

u=double((r/rad)^6)
weight=exp(-0.5*u)

oplot,weight[*,ny/2]*max(im),color=!red
oplot,im[*,ny/2]*weight[*,ny/2],color=!green
oplot,[1,1]*trim,[0,1e8],color=!blue
oplot,[1,1]*(nx-trim-1),[0,1e8],color=!blue

ims=im*weight
ims=ims[trim:nx-1-trim,trim:ny-trim-1]
ims=alog(ims)
mkhdr,h,4,[nx-2*trim,ny-2*trim] 
pscale=sxpar(hdr,'PSCALE')
print,"pscale = ",pscale
fxaddpar,h,'PSCALE',pscale

print,h

writefits,outfile,ims,h

return
end
