function simage_num_counts_frac,mag
;return the number of galaxies per deg^2 per mag
;as a fraction of the B*10^(A*mag) number counts

                                ;Frome Leauthaud et al , COSMOS      
slope_nc=0.332                 
amp_nc=0.000572836

A=slope_nc
B=amp_nc

;it was calibrated over this range
m1=21
m2=26

num=fltarr(n_elements(mag))
w=where(mag ge m1 and mag le m2,n)
if n gt 0 then num[w]=B*10.0^(A*mag[w])

;curvature parameters
;calibrated using Metcalf et al. 2001 MNRAS 323,795 

c1=[-0.0370877  ,    1.86531]
c2=[-0.0198820  ,    1.34200]

w=where(mag lt m1,n)
if n gt 0 then begin
   X0=m1
   Y0=alog10(B)+A*m1
   X=mag[w]
   c=c1
   num[w]=10.0^( c[0]*(X^2-X0^2)+c[1]*(X-X0)+Y0)
endif

w=where(mag gt m2,n)
if n gt 0 then begin
   X0=m2
   Y0=alog10(B)+A*m2
   X=mag[w]
   c=c2
   num[w]=10.0^( c[0]*(X^2-X0^2)+c[1]*(X-X0)+Y0)
endif

frac=num/(B*10.0^(A*mag))
frac=frac<1.0

return,frac
end
