function simage_shapecat2postage, $
  n_pixels=n_pixels, $
  file = file, $
  obj = obj, $
  psf = psf, $
  pixel_scale = pixel_scale, $
  const_psf_size = const_psf_size
  

if keyword_set(psf) then begin
    simage_shapelets_read_psf,psf,/WSNAP,n_max=12,pixsize=pixel_scale,diff_length=0.04,const_psf_size=const_psf_size
endif
if not keyword_set(n_pixels) then n_pixels = 39

simage_shapelets_read_shapecat, shapecat, file, /moments

input_gamma = [0., 0.]
inst_shear = [0., 0.]
seed = 1
rpos = 0B
pix_scale_catalogue = 0.04
pixsize = pixel_scale

                                ; Use full shapelet-simulated objects (and a decomp structure is convenient)
decomp         = simage_shapelets_shapecat2decomp(shapecat,obj) ; Extract shapelet object from catalogue
                                ;
decomp.coeffs  = decomp.coeffs*(pixsize/pix_scale_catalogue) ; Rescale to pixel scale
decomp.beta    = decomp.beta*pix_scale_catalogue/pixsize ; (integration within what pixels?)
                                ;shapelets_dilate,decomp,(pixsize/pix_scale_catalogue),/flux,/rad,/beta ; Should be equivalent
                                ;
decomp.n_pixels = [1,1] * n_pixels
decomp.x       = decomp.n_pixels / 2.0
decomp.beta = 0.3*decomp.beta
if keyword_set(psf) then decomp = simage_shapelets_convolve(decomp, psf)

print, "n_pix=", decomp.n_pixels, " cent=", decomp.x, " beta=", decomp.beta

return, decomp




end
