pro simage_test_shapecat,obj

obj_max=2835

if n_elements(obj) eq 0 then begin
    obj=2417                    ;pick one object
    print,'Using default object ',obj
endif

if obj gt obj_max then begin
    print,'obj must be <= ',obj_max
    return
endif

dir='/scr/davej/data/catalog/'
file=dir+'shapecat_total_trim.sav'

if file_test(file) eq 0 then begin
    print,'ERROR - cannot find shapelet catalog'
    print,'file = ',file
    return
endif else print,'Reading shapecat from file ',file

restore,file

;obj=800
;Bands are BVIZJH
;Use bands 1,2,3 which are V,I,Z to make a color image

bands=['B','V','I','Z','J','H']


window,0
!p.multi=[0,2,2]
for band=1,3 do begin
    shapecat=new_shapecat[band]
    decomp = simage_shapelets_shapecat2decomp(shapecat,obj) ; Extract shapelet object from catalogue
    ra=shapecat.sexra[obj]
    dec=shapecat.sexdec[obj]
    x=shapecat.sexx[obj]
    y=shapecat.sexy[obj]
    print,'Ra Dec ',ra,dec
    print,'X Y,',x,y

    simage_shapelets_recomp,decomp,rec
    if band eq 1 then begin
        ;find the size
        s=size(rec,/dim)
        grow=4                  ;expand the pixels by this
        nx=s[0]*grow
        ny=s[1]*grow
        im=bytarr(3,nx,ny)      ;a three color image
    endif
    tvim2,rec,tit=bands[band]
    im[band-1,*,*]=bytscl(congrid(rec,nx,ny))
    print,'shaplet center X=',decomp.x
endfor

!p.multi=0
window,1,xsize=nx,ysize=ny
tv,im,/true
return
end
