pro simage_udf_psf,psf,sexcat=sexcat,image=image,band=band,read=read,write=write,no_shex2=no_shex2

;Matt Ferry
;Procedure to extract UDF psf in specified band (#)
;  0: B
;  1: V
;  2: i
;  3: z
;  4: J
;  5: H

if not keyword_set(band) then band=0

image_array = ['h_udf_wfc_b_drz_img','h_udf_wfc_v_drz_img',$
               'h_udf_wfc_i_drz_img','h_udf_wfc_z_drz_img',$
               'h_nic3udfsf110w050_img','h_nic3udfsf160w050_img']

band_arr = ['b','v','i','z','j','h']
index_arr = [3205,8275,8275,3205,54,50]
path = simage_shapelets_paths(4,/silent)
;if band ge 4 and not keyword_set(sexcat) then begin
;    ;Need to correct sexcat to proper positions
;    shapelets_read_sexcat,sexcat,'h_nicast2_'+band_arr[band]
;    udf_shrink_sexcat,sexcat
;endif
if not keyword_set(read) then begin
    ;if band lt 4 then index = 8275 else index=3205;2320
    simage_shex,image_array[band],filename_output='udf_'+band_arr[band]+'_psf',index=index_arr[band],image=image,$
      sexcat=sexcat,/noise,chisq_target=0.85,/fits_read,/polar,/diamond
    simage_shapelets_read_shapecat,shapecat,'udf_'+band_arr[band]+'_psf'
    ;stop
    if not keyword_set(no_shex2) then begin
        sexcat.x[index_arr[band],*] = shapecat.x ;Update the position
        simage_shex,image_array[band],filename_output='udf_'+band_arr[band]+'_psf_2',index=index_arr[band],image=image,$
          sexcat=sexcat,/noise,chisq_target=0.85,/polar,/diamond
        simage_shapelets_read_shapecat,shapecat,'udf_'+band_arr[band]+'_psf_2'
    endif

    decomp = simage_shapelets_shapecat2decomp(shapecat,0)
    ;stop
    ;Rescale pixel size if band = 4 or 5
    if band ge 4 then begin
        decomp.beta = 0.202863/0.09*decomp.beta
        decomp.n_pixels=round(0.202863/0.09)*decomp.n_pixels
        decomp.x=round(0.202863/0.09)*decomp.x
    endif 
    simage_shapelets_recentre,decomp
    simage_shapelets_recomp,decomp,recomp
    weight = total(recomp)
    decomp.coeffs = decomp.coeffs/weight
    ;stop
    if keyword_set(write) then simage_shapelets_write,decomp,path+'udf_'+band_arr[band]+'_psf',/full_path
endif else begin
    restore,path+'udf_'+band_arr[band]+'_psf.decomp'
    decomp = structure
endelse 

psf = decomp

end
