pro simage_write_udf_scripts,udf=udf,snap=snap,dune=dune,$
dir=dir,dat=dat,area=area,exp_time=exp_time,driz=driz,mirr=mirr,riz=riz

if n_elements(dir) eq 0 then begin
    print,'ERROR - Must specify directory'
    return
endif

if n_elements(dat) eq 0 then begin
    date=str_sep(systime(0),' ')
    dat=date[1]+'_'+date[2]+'_TEST'
endif

if n_elements(area) eq 0 then area=11.49

get_lun,unit

space='  '

bands = ['b','v','i','z','j','h']

;;;;;;;;;;;;;;;;;;;;;;;;; UDF ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


if keyword_set(udf) then begin

    ;do the all version

    file=dir+'UDF_'+dat+'_all.batch'
    file_s=dir+'UDF_'+dat+'_all.script'
    
    openw,unit,file_s
    printf,unit,'hostname'
    printf,unit,'idl '+file
    close,unit
 
    openw,unit,file
    printf,unit,"print,'Started at ',systime(0)"
    printf,unit,"matt_path"
    printf,unit,"band_arr = ['b','v','i','z','j','h']"
    printf,unit,"dat='"+dat+"'"
    printf,unit,"area="+strcompress(area)
    printf,unit,space
    printf,unit,"n_begin=0"
    printf,unit,"n_end=5"
    printf,unit,space
    printf,unit,"out = band_arr+'_simUDF_'+dat"
    printf,unit,"dumpfile=band_arr[n_begin]+'_simUDF_'+dat+'.dump'"
    printf,unit,space
    printf,unit,"udf_snap_sim_3,/udf,n_begin=n_begin,n_end=n_end,out=out,/start,n_star=1,area=area,dumpfile=dumpfile"
    printf,unit,space
    printf,unit,"out = band_arr+'_simUDF_'+dat+'_star'"
    printf,unit,"udf_snap_sim_3,/udf,n_begin=n_begin,n_end=n_end,out=out,/start,n_gal=1,area=area"
    printf,unit,space
    printf,unit,"print,'Finished at ',systime(0)"
    printf,unit,"exit"
    close,unit
    
    ;do each band
    
    for i=0,5 do begin
        band=bands[i]
        ii=strcompress(i,/rem)
        
        file=dir+'UDF_'+dat+'_'+band+'.batch'
        file_s=dir+'UDF_'+dat+'_'+band+'.script'
        
        openw,unit,file_s
        printf,unit,'hostname'
        printf,unit,'idl '+file
        close,unit
        
        openw,unit,file
        printf,unit,"print,'Started at ',systime(0)"
        printf,unit,"matt_path"
        printf,unit,"band_arr = ['b','v','i','z','j','h']"
        printf,unit,"dat='"+dat+"'"
        printf,unit,"area="+strcompress(area)
        printf,unit,space
        printf,unit,"n_begin="+ii
        printf,unit,"n_end="+ii
        printf,unit,space
        printf,unit,"out = band_arr+'_simUDF_'+dat"
        printf,unit,"dumpfile=band_arr[n_begin]+'_simUDF_'+dat+'.dump'"
        printf,unit,space
        printf,unit,"udf_snap_sim_3,/udf,n_begin=n_begin,n_end=n_end,out=out,/start,n_star=1,area=area,dumpfile=dumpfile"
        printf,unit,space
        printf,unit,"out = band_arr+'_simUDF_'+dat+'_star'"
        printf,unit,"udf_snap_sim_3,/udf,n_begin=n_begin,n_end=n_end,out=out,/start,n_gal=1,area=area"
        printf,unit,space
        printf,unit,"print,'Finished at ',systime(0)"
        printf,unit,"exit"
        close,unit
    endfor
    
endif


;;;;;;;;;;;;;;;;;;;;;;;;;;;; SNAP ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

if keyword_set(snap) then begin

    if n_elements(exp_time) eq 0 then begin
        print,'ERROR - Must give exp_time for SNAP'
        return
    endif
    exptime=strcompress(exp_time,/rem)

    if n_elements(driz) eq 0 then begin
        print,'ERROR - Must give driz for SNAP'
        return
    endif
    drizs=strcompress(driz,/rem)
    
    ;do the all version

    file=dir+'SNAP_'+dat+'_all.batch'
    file_s=dir+'SNAP_'+dat+'_all.script'
    
    openw,unit,file_s
    printf,unit,'hostname'
    printf,unit,'idl '+file
    close,unit
 
    openw,unit,file
    printf,unit,"print,'Started at ',systime(0)"
    printf,unit,"matt_path"
    printf,unit,"band_arr = ['b','v','i','z','j','h']"
    printf,unit,"dat='"+dat+"'"
    printf,unit,"area="+strcompress(area)
    printf,unit,"exptime="+exptime
    printf,unit,"driz="+drizs
    printf,unit,"expt=strcompress(exptime,/rem)"
    printf,unit,space
    printf,unit,"n_begin=0"
    printf,unit,"n_end=5"
    printf,unit,space
    printf,unit,"out = band_arr+'_SNAP_'+dat+'_'+expt"
    printf,unit,"dumpfile=band_arr[n_begin]+'_SNAP_'+dat+'_'+expt+'.dump'"
    printf,unit,space
    printf,unit,"udf_snap_sim_3,/snap,n_begin=n_begin,n_end=n_end,out=out,/start,n_star=1,area=area,dumpfile=dumpfile,exposure_time = exptime,driz=driz"
    printf,unit,space
    printf,unit,"out = band_arr+'_SNAP_'+dat+'_star'+'_'+expt"
    printf,unit,"udf_snap_sim_3,/snap,n_begin=n_begin,n_end=n_end,out=out,/start,n_gal=1,area=area,exposure_time = exptime,driz=driz"
    printf,unit,space
    printf,unit,"print,'Finished at ',systime(0)"
    printf,unit,"exit"
    close,unit
    
    ;do each band
    
    for i=0,5 do begin
        band=bands[i]
        ii=strcompress(i,/rem)
        
        file=dir+'SNAP_'+dat+'_'+band+'.batch'
        file_s=dir+'SNAP_'+dat+'_'+band+'.script'

        openw,unit,file_s
        printf,unit,'hostname'
        printf,unit,'idl '+file
        close,unit
        
        openw,unit,file
        printf,unit,"print,'Started at ',systime(0)"
        printf,unit,"matt_path"
        printf,unit,"band_arr = ['b','v','i','z','j','h']"
        printf,unit,"dat='"+dat+"'"
        printf,unit,"area="+strcompress(area)
        printf,unit,"exptime="+exptime
        printf,unit,"driz="+drizs
        printf,unit,"expt=strcompress(exptime,/rem)"
        printf,unit,space
        printf,unit,"n_begin="+ii
        printf,unit,"n_end="+ii
        printf,unit,space
        printf,unit,"out = band_arr+'_SNAP_'+dat+'_'+expt"
        printf,unit,"dumpfile=band_arr[n_begin]+'_SNAP_'+dat+'_'+expt+'.dump'"
        printf,unit,space
        printf,unit,"udf_snap_sim_3,/snap,n_begin=n_begin,n_end=n_end,out=out,/start,n_star=1,area=area,dumpfile=dumpfile,exposure_time = exptime,driz=driz"
        printf,unit,space
        printf,unit,"out = band_arr+'_SNAP_'+dat+'_star_'+expt"
        printf,unit,"udf_snap_sim_3,/snap,n_begin=n_begin,n_end=n_end,out=out,/start,n_gal=1,area=area,exposure_time = exptime,driz=driz"
        printf,unit,space
        printf,unit,"print,'Finished at ',systime(0)"
        printf,unit,"exit"
        close,unit
    endfor
    
endif

;;;;;;;;;;;;;;;;;;;;;;;;;;;; DUNE ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

if keyword_set(dune) then begin

    if n_elements(exp_time) eq 0 then begin
        print,'ERROR - Must give exp_time for DUNE'
        return
    endif
    exptime=strcompress(exp_time,/rem)

    if n_elements(driz) eq 0 then begin
        print,'ERROR - Must give driz for DUNE'
        return
    endif
    drizs=strcompress(driz,/rem)

    if n_elements(riz) eq 0 then begin
        print,'ERROR - Must give riz for DUNE'
        return
    endif
    rizs=strcompress(riz,/rem)

    if n_elements(mirr) eq 0 then begin
        print,'ERROR - Must give mirr for DUNE'
        return
    endif
    mirrs=strcompress(mirr,/rem)
    
    
    ;do the all version

    file=dir+'DUNE_'+dat+'_all.batch'
    file_s=dir+'DUNE_'+dat+'_all.script'
    
    openw,unit,file_s
    printf,unit,'hostname'
    printf,unit,'idl '+file
    close,unit
 
    openw,unit,file
    printf,unit,"print,'Started at ',systime(0)"
    printf,unit,"matt_path"
    printf,unit,"band_arr = ['b','v','i','z','j','h']"
    printf,unit,"dat='"+dat+"'"
    printf,unit,"area="+strcompress(area)
    printf,unit,"exptime="+exptime
    printf,unit,"driz="+drizs
    printf,unit,"riz="+rizs
    printf,unit,"mirr="+mirrs
    printf,unit,"expt=strcompress(exptime,/rem)"
    printf,unit,space
    printf,unit,"n_begin=0"
    printf,unit,"n_end=5"
    printf,unit,space
    printf,unit,"out = band_arr+'_DUNE_'+dat+'_'+expt"
    printf,unit,"dumpfile=band_arr[n_begin]+'_DUNE_'+dat+'_'+expt+'.dump'"
    printf,unit,space
    printf,unit,"udf_snap_sim_3,/dune,n_begin=n_begin,n_end=n_end,out=out,/start,n_star=1,area=area,$"
    printf,unit,"dumpfile=dumpfile,exposure_time = exptime,driz=driz,mirr=mirr,riz=riz"
    printf,unit,space
    printf,unit,"out = band_arr+'_DUNE_'+dat+'_star'+'_'+expt"
    printf,unit,"udf_snap_sim_3,/dune,n_begin=n_begin,n_end=n_end,out=out,/start,n_gal=1,area=area,$
    printf,unit,"exposure_time = exptime,driz=driz,mirr=mirr,riz=riz"
    printf,unit,space
    printf,unit,"print,'Finished at ',systime(0)"
    printf,unit,"exit"
    close,unit
    
    ;do each band
    
    for i=0,5 do begin
        band=bands[i]
        ii=strcompress(i,/rem)
        
        file=dir+'DUNE_'+dat+'_'+band+'.batch'
        file_s=dir+'DUNE_'+dat+'_'+band+'.script'
        
        openw,unit,file_s
        printf,unit,'hostname'
        printf,unit,'idl '+file
        close,unit
        
        openw,unit,file
        printf,unit,"print,'Started at ',systime(0)"
        printf,unit,"matt_path"
        printf,unit,"band_arr = ['b','v','i','z','j','h']"
        printf,unit,"dat='"+dat+"'"
        printf,unit,"area="+strcompress(area)
        printf,unit,"exptime="+exptime
        printf,unit,"driz="+drizs
        printf,unit,"riz="+rizs
        printf,unit,"mirr="+mirrs
        printf,unit,"expt=strcompress(exptime,/rem)"
        printf,unit,space
        printf,unit,"n_begin="+ii
        printf,unit,"n_end="+ii
        printf,unit,space
        printf,unit,"out = band_arr+'_DUNE_'+dat+'_'+expt"
        printf,unit,"dumpfile=band_arr[n_begin]+'_DUNE_'+dat+'_'+expt+'.dump'"
        printf,unit,space
        printf,unit,"udf_snap_sim_3,/dune,n_begin=n_begin,n_end=n_end,out=out,/start,n_star=1,area=area,$"
        printf,unit,"dumpfile=dumpfile,exposure_time = exptime,driz=driz,mirr=mirr,riz=riz"
        printf,unit,space
        printf,unit,"out = band_arr+'_DUNE_'+dat+'_star'+'_'+expt"
        printf,unit,"udf_snap_sim_3,/dune,n_begin=n_begin,n_end=n_end,out=out,/start,n_gal=1,area=area,$
        printf,unit,"exposure_time = exptime,driz=driz,mirr=mirr,riz=riz"
        printf,unit,space
        printf,unit,"print,'Finished at ',systime(0)"
        printf,unit,"exit"
        close,unit
    endfor
endif




free_lun,unit

return
end
