pro cosmos_psf_size,im,x0,ee50,fwhm,ylog=ylog,beta=beta

file='~/data/sims/data/COSMOS-PSF-TinyTim.fits'
imo=mrdfits(file)

if n_elements(beta) eq 0 then beta=2.0

xstart=30
ystart=30
sso=size(imo,/dim)

im=imo[xstart:sso[0]-xstart-1,ystart:sso[1]-ystart-1]

ss=size(im)
nx=ss(1)
ny=ss(2)
l=lindgen(nx*ny)
x= double(l MOD nx)
y=double(l/nx)

fit_1_2dt,im,pars,nu=2
cenx=pars[1]
ceny=pars[2]

print,'centroid ',cenx,ceny

;x=x-cenx
;y=y-ceny

r=sqrt((x-cenx)^2+(y-ceny)^2)

m=reform(one_2dt_nu2(x,y,pars),nx,ny)

!p.multi=[0,1,2]

plot,im[*,ny/2],ylog=ylog
oplot,m[*,ny/2],color=!red

plot,im[nx/2,*],ylog=ylog
oplot,m[ny/2,*],color=!red

x0=[cenx,ceny]

psf=im
p=shapelets_decomp(psf,beta,12,x0=x0)

get_ee50,p,ee50,/plot,fwhm=fwhm

return
end
