pro gary_udf_mask,xc,yc,bin,mask,den=den,area=area,draw=draw
;return a mask (true or false) whether points x,y are in the UDF Mask 
;bin is the binning of xc or yc

if n_params() eq 0 then begin
    print,'-syntax gary_udf_mask,x,y,bin,mask'
    return
endif


mbin=2.0                        ;binning at which mask was made

x =[ 2628.0673   ,    4838.9727  ,     2620.8657   ,    345.14549   ,    2628.0673 ]*mbin
y =[ 4910.9942   ,    2707.2905  ,     301.94073   ,    2649.6773   ,    4910.9942 ]*mbin

if keyword_set(draw) then oplot,x/bin,y/bin,color=!magenta


area=10.3560                    ;arcmin^2

xp=xc*float(bin)
yp=yc*float(bin)

mask=replicate(0b,n_elements(xp))
;four cuts
mask=replicate(0b,n_elements(xp))
true=[1,0,0,1]
for i=0, 3 do begin
    m=(y[i+1]-y[i])/(x[i+1]-x[i])
    b=(x[i+1]*y[i]-x[i]*y[i+1])/(x[i+1]-x[i])
    iflag=(yp gt (m*xp+b)) eq true[i]
    mask=mask+iflag
endfor
mask=(mask < 1b) eq 0
wgood=where(mask,ngood)
wbad=where(mask eq 0,nbad)
print,'nbad = ',nbad
print,'good = ',ngood

den=ngood/area
print,'density is ',den,'  objects/arcmin^2 if they cover the mask'

return
end

