pro get_ludo_stars,file,xc,yc,im=im,cat=cat,hdr=hdr

p=strpos(file,'.fits')
pref=strmid(file,0,p)
starfile=pref+'_goodstars.dat'

if n_elements(im) eq 0 then im=mrdfits(file,0,hdr)

s=size(im,/dim)
nx=s[0]
ny=s[1]

if n_elements(cat) eq 0 then begin
    catfile='~/junk.fits'
    cmd='sexy '+file+' '+catfile
    spawn,cmd
    cat=mrdfits(catfile,1)
endif

z=sxpar(hdr,'MAGZP')

print,'Mag ZP',z

x=cat.x_image-1
y=cat.y_image-1

slide,im,max=0.2
plotsave

tvcircle,20,x,y,/data,color=!yellow

mag=z+cat.mag_auto
window,1

r2=cat.x2_image+cat.y2_image


plot,r2,mag,psym=1,xr=[0,30],yr=[15,27]

max_mag=22
oplot,[-100,100],[1,1]*max_mag,color=!red,linest=2

r2_min=6.0
r2_max=18.

oplot,[1,1]*r2_min,[-100,100],color=!green,linest=2
oplot,[1,1]*r2_max,[-100,100],color=!blue,linest=2

rr=findgen(10)*10
slope=0.6
;off=20.3

print,'click point'

cursor,xp,yp,/data,/down

off=yp-slope*(10-xp)

oplot,rr,slope*(10-rr)+off,color=!red,linest=2

buf=50.0
w=where(mag lt max_mag and r2 gt r2_min and r2 lt r2_max and mag lt (slope*(10-r2)+off) $
and x gt buf and x lt nx-buf and y gt buf and y lt ny-buf,num)

print,num,' star candidates'

oplot,r2[w],mag[w],psym=1,color=!magenta

plotrestore
tvcircle,20,x[w],y[w],/data,color=!magenta

window,2
!p.multi=0
photo_2dt,im,x[w],y[w],counts,xc,yc,ixx,iyy,ixy,nu,chi,flag,stamps,/plot
!p.multi=0

chi_max=1
ww=where(chi lt 2,nn)
w=w[ww]
m=z-2.5*alog10(counts[ww])
rad=sqrt(ixx[ww]+iyy[ww])
xc=xc[ww]
yc=yc[ww]

plot,rad,m,xr=[1,3],psym=4,/yno

mrad=median(rad)
;oplot,[1,1]*mrad,[-100,100],color=!green,linest=2

;nsig=1.8
nsig=3.0
niter=7

sigma_clip_rob,rad,mm,ss,nsig=nsig,niter=niter,/print
oplot,[1,1]*mm,[-100,100],color=!green,linest=2


ww=where(abs(rad-mm) lt nsig*ss,num)
oplot,rad[ww],m[ww],psym=4,color=!red

print,num,' stars'

w=w[ww]
m=m[ww]
rad=rad[ww]
xc=xc[ww]
yc=yc[ww]

plotrestore
tvcircle,15,x[w],y[w],/data,color=!green
tvcircle,25,xc,yc,/data,color=!green

min_d=20.0

dd=fltarr(num)

for i=0, num-1 do begin
    d=sqrt((x-xc[i])^2 + (y-yc[i])^2)
    s=sort(d)
    d=d[s]
    dmin=d[1]
    dd[i]=dmin
    ;print,w[i],dmin
    tvcircle,10,x[s[1]],y[s[1]],color=!red,/data
    if dmin lt min_d then tvcircle,20,x[w[i]],y[w[i]],color=!blue,/data
endfor

ww=where(dd gt min_d,num)
print,num,' final  stars'

w=w[ww]
m=m[ww]
rad=rad[ww]
xc=xc[ww]
yc=yc[ww]

tvcircle,40,xc,yc,/data,color=!orange

window,0,xsize=700,ysize=700
tvim2,im,r=[0,1]
tvcircle,40,xc,yc,/data,color=!orange

get_lun,unit
openw,unit,starfile
for i=0, num-1 do printf,unit,xc[i],yc[i],m[i]
free_lun,unit

print,'wrote to  ', starfile


return
end

