pro get_udf_throughput,tot_trans,cosmos=cosmos
;

dir='/Users/djohnsto/acs_trans/trans/'

fudgefac=1.0
;fudgefac=0.64

print,'USING FUDGE FACTOR = ',fudgefac

lam_min=2.5e3
lam_max=1.15e4
lnum=10000
lambda=(lam_max-lam_min)*findgen(lnum)/(lnum-1)+lam_min

;window

file=dir+'acs_wfc_ebe_win12f_005_syn.fits'
outfile=dir+'throughput_lam_trans_BViz.fits'
d=mrdfits(file,1,hdr)
lam1=d.wavelength
t1=d.throughput
tran1=interpol(t1,lam1,lambda)

ymax=1.0
;ymax=0.5 to compare to coe et al.
plot,lam1,t1,yr=[0,ymax]

;mirror

file=dir+'acs_wfc_im123_004_syn.fits'

d=mrdfits(file,1,hdr)
lam2=d.wavelength
t2=d.throughput
tran2=interpol(t2,lam2,lambda)

oplot,lam2,t2,color=!yellow

;ccd use ccd1 I guess

file=dir+'acs_wfc_ccd1_017_syn.fits'

d=mrdfits(file,1,hdr)
lam3=d.wavelength
t3=d.throughput
tran3=interpol(t3,lam3,lambda)

;the HST OTA

file=dir+'hst_ota_006.fits'

d=mrdfits(file,1,hdr)
lam4=d.wavelength
t4=d.throughput
tran4=interpol(t4,lam4,lambda)

oplot,lam4,t4,color=!blue,linest=2

trans=tran1*tran2*tran3*tran4
;this is the instrument sensitivity, prior to filters

oplot,lambda,trans,linest=1
trans=trans*fudgefac
oplot,lam3,t3,color=!green
oplot,lambda,trans,linest=2

fils=['B','V','i','z']
nfils=4

if keyword_set(cosmos) then begin
    fil_files=dir+['acs_f435w_004_syn.fits','acs_f606w_005_syn.fits','acs_f814w_003_syn.fits','acs_f850lp_004_syn.fits']
endif else begin 
    fil_files=dir+['acs_f435w_004_syn.fits','acs_f606w_005_syn.fits','acs_f775w_003_syn.fits','acs_f850lp_004_syn.fits']
endelse

cols=[!blue,!magenta,!red,!orange]

data=fltarr(lnum,nfils+2)
data[*,0]=lambda
data[*,1]=trans

tot_trans=fltarr(4)

dx=shift(lambda,-1)-lambda
dx=dx[0:lnum-2]

area=4.5239

zpt=fltarr(nfils)
Wid=zpt
msky=zpt
msig=zpt

get_zodi,ll,zz
zod=interpol(zz,ll,lambda)
c=3e18

;exposure_time = [134880.,135320.,347110.,346620.,196730.,209849.]
exposure_time = [134880.,135320.,347110.,346620.]

for i=0,nfils-1 do begin
    d=mrdfits(fil_files[i],1,hdr)
    lam=d.wavelength
    t=d.throughput
    oplot,lam,t,color=cols[i]
    tp=interpol(t,lam,lambda)
    tptot=tp*trans
    oplot,lambda,tptot,color=cols[i]
    filter_zeropoint,lambda,tptot,area,z,w
    zpt[i]=z
    Wid[i]=w
    F=int_tabulated(lambda,zod*tptot*lambda)/(c*W)
    msky[i]=-2.5*alog10(F)-48.6
    msig[i]=(z+msky[i])/2.0
    data[*,i+2]=tp
    y=0.5*(tptot+shift(tptot,-1))
    y=y[0:lnum-2]
    tot_trans[i]=total(dx*y)
endfor

writefits,outfile,data

msig=msig+1.25*alog10(exposure_time)

print,'Filter           B(435)       V(606)       i(775)        z(850LP)'
print,'----------------------------------------------------------------------'
print,'tot_trans  ',tot_trans
print,'Zpt ',zpt
print,'W ',wid
print,'msky ' ,msky
print,'msig ',msig
print
print,'USED FUDGE FACTOR = ',fudgefac
print

return
end



