function snapix_get_psf,pixel_scale,path=path,verbose=verbose

if not keyword_set(path) then begin 
    path='.'
    message,"Assuming path to be "+path,/info
endif else begin
; Strip any trailing foward-slash.
    last_char=strmid(path,strlen(path)-1,strlen(path))
    if last_char eq '/' then begin
        path=strmid(path,0,strlen(path)-1)
    endif
endelse
message,"Path="+path,/info

restore,path+'/snap_psfs.sav',verbose=verbose

case pixel_scale of
    0.04: return,psf04
    0.05: return,psf05
    0.06: return,psf06
    0.07: return,psf07
    0.08: return,psf08
    0.09: return,psf09
    0.10: return,psf10
    0.11: return,psf11
    0.12: return,psf12
    0.13: return,psf13
    0.14: return,psf14
    0.15: return,psf15
    0.16: return,psf16
    else  : message,'Error: no psf with '+strtrim(pixel_scale,2)+'" pixels'
endcase

return,-1

end
