function snapix_get_psf_decomp,name,file2,path=path,dostop=dostop

psf_scale=1.
pixel_scale=1.

print
message,'Doing '+name,/info

; Set the parameters needed by shapelets_decomp.
n_max=20
detect_thresh=100000
sigma=0.3
beta=9.86
psf_scale=0.01
nfwhm=40
case name of
    'psf04': begin
        pixel_scale=0.04
    end
    'psf05':begin
        pixel_scale=0.05
    end
    'psf06': begin
        pixel_scale=0.06
    end
    'psf07': begin
        pixel_scale=0.07
    end
    'psf08': begin
        pixel_scale=0.08
    end
    'psf09': begin
        pixel_scale=0.09
    end
    'psf10': begin
        pixel_scale=0.10
    end
    'psf11': begin
        pixel_scale=0.11
    end
    'psf12': begin
        pixel_scale=0.12
    end
    'psf13': begin
        pixel_scale=0.13
    end
    'psf14': begin
        pixel_scale=0.14
    end
    'psf15': begin
        pixel_scale=0.15
    end
    'psf16': begin
        pixel_scale=0.16
    end
    else: message,'Do not recognize '+name
endcase

file=path+'/'+file2+'.fits'
rfile=path+'/'+file2
shapelets_read_image,img,file,/fullpath
cmd='sex '+file+$
    ' -c '+rfile+'.sex'+$
    ' -CATALOG_NAME '+rfile+'.sexcat'+$
    ' -PARAMETERS_NAME '+path+'/default.param'+$
    ' -FILTER_NAME '+path+'/default.conv'+$
    ' -STARNNW_NAME '+path+'/default.nnw'+$
    ' -DETECT_THRESH '+strtrim(detect_thresh,2)
message,cmd,/info
spawn,cmd

message,'Original PSF moments:',/info
two_d_moments,file2+'.fits',$
              weight='circular gaussian',sigma=sigma,$
              theta_px=[psf_scale,pixel_scale],moms=moms,$
              detect_thresh=detect_thresh,/norrg
cent=[moms.Ix,moms.Iy]/moms.scale
print,'n_pixels=',(size(img.image))[[1,2]]
print,'n_pixels/sigma=',(size(img.image))[[1,2]]/sigma*psf_scale
orig_cent=[moms.Ix,moms.Iy]/moms.scale
print,'cent=',orig_cent

shapelets_read_sexcat,sexcat,rfile+'.sexcat',/full
print,'sexcat fwhm',sexcat.fwhm
print,'sexcat x'
print,sexcat.x
print,'moving x[0] by',round(sexcat.x[1]-sexcat.x[0])
sexcat.x[0]=sexcat.x[0]+round(sexcat.x[1]-sexcat.x[0])
window,0
pstamp=shapelets_sexcat2pstamp(img,$ ; IMAGE
                               sexcat,$ ; SEXCAT
                               0,$ ; ID
                               nfwhm=nfwhm,$
                               plotit=1B $
                              )
print,'pstamp n_pixels=',(size(pstamp.image))[[1,2]]
print,'n_pixels/sigma=',(size(pstamp.image))[[1,2]]/sigma*psf_scale
fits_write,name+'_pstamp.fits',pstamp.image
message,'Pstamp PSF moments:',/info
two_d_moments,name+'_pstamp.fits',$
              weight='circular gaussian',sigma=sigma,$
              theta_px=[psf_scale,pixel_scale],moms=moms,$
              detect_thresh=detect_thresh,/norrg
cent=[moms.Ix,moms.Iy]/moms.scale
print,'cent=',cent
;shapelets_focus,pstamp,focus,decomp

shapelets_decomp,pstamp.image,beta,n_max,decomp,$
                 x0=orig_cent-[pstamp.im_ran[0],pstamp.im_ran[2]]+0.5
;shapelets_decomp,img.image,beta,n_max,decomp,$
;                 x0=cent
decomp.x=fix(decomp.x)+0.5

shapelets_recomp,decomp,recomp
fits_write,name+'_recomp1.fits',recomp
message,'Initial recomped PSF moments:',/info
two_d_moments,name+'_recomp1.fits',$
              weight='circular gaussian',sigma=sigma,$
              theta_px=[psf_scale,pixel_scale],moms=moms,$
              detect_thresh=detect_thresh,/norrg
cent=[moms.Ix,moms.Iy]/moms.scale
print,'cent=',cent
print,'shapelets_cent-cent=',shapelets_centroid(decomp)-decomp.x

while (abs(shapelets_centroid(decomp)-decomp.x))[0] gt 1e-2 or $
  (abs(shapelets_centroid(decomp)-decomp.x))[1] gt 1e-2 do begin
    message,'Recentering',/info
    shapelets_translate,decomp,-(shapelets_centroid(decomp)-decomp.x),order=4
    shapelets_recomp,decomp,recomp
    fits_write,name+'_recomp2.fits',recomp
    two_d_moments,name+'_recomp2.fits',$
                  weight='circular gaussian',sigma=sigma,$
                  theta_px=[pixel_scale,pixel_scale],moms=moms,$
                  detect_thresh=detect_thresh,/norrg,cent_err=1e-10,$
                  /silent
    print,'shapelets_cent-cent=',shapelets_centroid(decomp)-decomp.x
endwhile

fact=1

shapelets_recomp,decomp,recomp
fits_write,name+'_recomp2.fits',recomp
message,'Recomped PSF moments after recentering:',/info
two_d_moments,name+'_recomp2.fits',$
              weight='circular gaussian',sigma=sigma,$
              theta_px=[psf_scale,pixel_scale],moms=moms,$
              detect_thresh=detect_thresh,/norrg
cent=[moms.Ix,moms.Iy]/moms.scale
print,'cent=',cent
print,'shapelets_cent-cent=',shapelets_centroid(decomp)-decomp.x

decomp.n_pixels=fact*round(decomp.n_pixels*psf_scale/pixel_scale)
decomp.x=fix(fact*decomp.x*psf_scale/pixel_scale)+0.5
decomp.beta=decomp.beta*psf_scale/pixel_scale
decomp.coeffs=decomp.coeffs/shapelets_flux(decomp)

print,'n_pixels=',decomp.n_pixels
;shapelets_recentre,decomp

shapelets_recomp,decomp,recomp
fits_write,name+'_recomp.fits',recomp
message,'Recomped PSF moments after rescaling:',/info
two_d_moments,name+'_recomp.fits',$
              weight='circular gaussian',sigma=sigma,$
              theta_px=[pixel_scale,pixel_scale],moms=moms,$
              detect_thresh=detect_thresh,/norrg,cent_err=1e-10
print,'n_pixels=',(size(recomp))[[1,2]]
print,'n_pixels/sigma=',(size(recomp))[[1,2]]/sigma*pixel_scale
cent=[moms.Ix,moms.Iy]/moms.scale
print,'cent=',cent
print,'shapelets_cent-cent=',shapelets_centroid(decomp)-decomp.x

window,0
shapelets_plot_image,pstamp.image,/clog
window,1
shapelets_recomp,decomp,img
shapelets_plot_image,img,/clog

if keyword_set(dostop) then stop else wait,5

return,decomp

end

pro snapix_prep_psfs,path=path,dostop=dostop

compile_opt idl2

if not keyword_set(path) then begin 
    path='.'
    message,"Assuming path to be "+path,/info
endif else begin
; Strip any trailing foward-slash.
    last_char=strmid(path,strlen(path)-1,strlen(path))
    if last_char eq '/' then begin
        path=strmid(path,0,strlen(path)-1)
    endif
endelse
message,"Path="+path,/info

psf04=snapix_get_psf_decomp('psf04','psfA_smooth',path=path,dostop=dostop)
psf05=snapix_get_psf_decomp('psf05','psfA_smooth',path=path,dostop=dostop)
psf06=snapix_get_psf_decomp('psf06','psfA_smooth',path=path,dostop=dostop)
psf07=snapix_get_psf_decomp('psf07','psfA_smooth',path=path,dostop=dostop)
psf08=snapix_get_psf_decomp('psf08','psfA_smooth',path=path,dostop=dostop)
psf09=snapix_get_psf_decomp('psf09','psfA_smooth',path=path,dostop=dostop)
psf10=snapix_get_psf_decomp('psf10','psfA_smooth',path=path,dostop=dostop)
psf11=snapix_get_psf_decomp('psf11','psfA_smooth',path=path,dostop=dostop)
psf12=snapix_get_psf_decomp('psf12','psfA_smooth',path=path,dostop=dostop)
psf13=snapix_get_psf_decomp('psf13','psfA_smooth',path=path,dostop=dostop)
psf14=snapix_get_psf_decomp('psf14','psfA_smooth',path=path,dostop=dostop)
psf15=snapix_get_psf_decomp('psf15','psfA_smooth',path=path,dostop=dostop)
psf16=snapix_get_psf_decomp('psf16','psfA_smooth',path=path,dostop=dostop)

save,file=path+"/snap.sav",psf04,psf05,psf06,$
     psf07,psf08,psf09,psf10,psf11,psf12,psf13,psf14,psf15,psf16

end
