function step3_get_psf_decomp,name,file2,path=path,dostop=dostop

if not keyword_set(psf_scale) then psf_scale=1.
if not keyword_set(pixel_scale) then pixel_scale=1.

print
message,'Doing '+name,/info

; Set the parameters needed by shapelets_decomp.
n_max=20
case name of
    'psfA': begin
        beta=9.86
        psf_scale=0.01
        pixel_scale=0.05
        detect_thresh=100000
        sigma=0.3
        nfwhm=40
    end
    'psfB':begin
        beta=9.86
        psf_scale=0.01
        pixel_scale=0.10
        detect_thresh=100000
        sigma=0.3
        nfwhm=40
    end
    'psfC': begin
        beta=16.0
        psf_scale=0.01
        pixel_scale=0.10
        detect_thresh=10000
        sigma=0.3*(2/1.4)
        nfwhm=40
    end
    'psfD': begin
        beta=1.71667
        psf_scale=0.05
        pixel_scale=0.04
        detect_thresh=1000
        sigma=0.175
        nfwhm=18
    end
    'psfE': begin
        beta=1.71667
        psf_scale=0.05
        pixel_scale=0.10
        detect_thresh=1000
        sigma=0.175
        nfwhm=18
    end
    'psfF': begin
        beta=1.71667
        psf_scale=0.05
        pixel_scale=0.04
        detect_thresh=1000
        sigma=0.175
        nfwhm=18
    end
    'psfG': begin
        beta=1.71667
        psf_scale=0.05
        pixel_scale=0.10
        detect_thresh=1000
        sigma=0.175
        nfwhm=18
    end
    'psfH': begin
        beta=1.71667
        psf_scale=0.05
        pixel_scale=0.04
        detect_thresh=1000
        sigma=0.175
        nfwhm=18
    end
    'psfI': begin
        beta=1.71667
        psf_scale=0.05
        pixel_scale=0.04
        detect_thresh=1000
        sigma=0.175
        nfwhm=18
    end
    'psfJ': begin
        beta=1.71667
        psf_scale=0.05
        pixel_scale=0.04
        detect_thresh=1000
        sigma=0.175
        nfwhm=18
    end
    'psfK': begin
        beta=1.71667
        psf_scale=0.05
        pixel_scale=0.04
        detect_thresh=1000
        sigma=0.175
        nfwhm=18
    end
    'psfL': begin
        beta=1.71667
        psf_scale=0.05
        pixel_scale=0.04
        detect_thresh=1000
        sigma=0.175
        nfwhm=18
    end
endcase

;nfwhm=29

file=path+'/'+file2+'.fits'
rfile=path+'/'+file2
shapelets_read_image,img,file,/fullpath
cmd='sex '+file+$
    ' -c '+rfile+'.sex'+$
    ' -CATALOG_NAME '+rfile+'.sexcat'+$
    ' -PARAMETERS_NAME '+path+'/default.param'+$
    ' -FILTER_NAME '+path+'/default.conv'+$
    ' -STARNNW_NAME '+path+'/default.nnw'+$
    ' -DETECT_THRESH '+strtrim(detect_thresh,2)
message,cmd,/info
spawn,cmd

message,'Original PSF moments:',/info
two_d_moments,file2+'.fits',$
              weight='circular gaussian',sigma=sigma,$
              theta_px=[psf_scale,pixel_scale],moms=moms,$
              detect_thresh=detect_thresh,/norrg
cent=[moms.Ix,moms.Iy]/moms.scale
print,'n_pixels=',(size(img.image))[[1,2]]
print,'n_pixels/sigma=',(size(img.image))[[1,2]]/sigma*psf_scale
orig_cent=[moms.Ix,moms.Iy]/moms.scale
print,'cent=',orig_cent

shapelets_read_sexcat,sexcat,rfile+'.sexcat',/full
message,'Sexcat fwhm=',/info
print,'sexcat fwhm',sexcat.fwhm
print,'sexcat x',sexcat.x
print,'moving x[0] by',round(sexcat.x[1]-sexcat.x[0])
sexcat.x[0]=sexcat.x[0]+round(sexcat.x[1]-sexcat.x[0])
window,0
pstamp=shapelets_sexcat2pstamp(img,$ ; IMAGE
                               sexcat,$ ; SEXCAT
                               0,$ ; ID
                               nfwhm=nfwhm,$
                               plotit=1B $
                              )
print,'pstamp n_pixels=',(size(pstamp.image))[[1,2]]
print,'n_pixels/sigma=',(size(pstamp.image))[[1,2]]/sigma*psf_scale
fits_write,name+'_pstamp.fits',pstamp.image
message,'Pstamp PSF moments:',/info
two_d_moments,name+'_pstamp.fits',$
              weight='circular gaussian',sigma=sigma,$
              theta_px=[psf_scale,pixel_scale],moms=moms,$
              detect_thresh=detect_thresh,/norrg
cent=[moms.Ix,moms.Iy]/moms.scale
print,'cent=',cent
;shapelets_focus,pstamp,focus,decomp

shapelets_decomp,pstamp.image,beta,n_max,decomp,$
                 x0=orig_cent-[pstamp.im_ran[0],pstamp.im_ran[2]]+0.5
;shapelets_decomp,img.image,beta,n_max,decomp,$
;                 x0=cent
decomp.x=fix(decomp.x)+0.5

shapelets_recomp,decomp,recomp
fits_write,name+'_recomp1.fits',recomp
message,'Initial recomped PSF moments:',/info
two_d_moments,name+'_recomp1.fits',$
              weight='circular gaussian',sigma=sigma,$
              theta_px=[psf_scale,pixel_scale],moms=moms,$
              detect_thresh=detect_thresh,/norrg
cent=[moms.Ix,moms.Iy]/moms.scale
print,'cent=',cent
print,'shapelets_cent-cent=',shapelets_centroid(decomp)-decomp.x

while (abs(shapelets_centroid(decomp)-decomp.x))[0] gt 1e-2 or $
  (abs(shapelets_centroid(decomp)-decomp.x))[1] gt 1e-2 do begin
    message,'Recentering',/info
    shapelets_translate,decomp,-(shapelets_centroid(decomp)-decomp.x),order=4
    shapelets_recomp,decomp,recomp
    fits_write,name+'_recomp2.fits',recomp
    two_d_moments,name+'_recomp2.fits',$
                  weight='circular gaussian',sigma=sigma,$
                  theta_px=[pixel_scale,pixel_scale],moms=moms,$
                  detect_thresh=detect_thresh,/norrg,cent_err=1e-10,$
                  /silent
    print,'shapelets_cent-cent=',shapelets_centroid(decomp)-decomp.x
endwhile

; Set the parameters need by shapelets_rotate.
;e=shapelets_ellipticity(decomp,/gaussian)
e=moms.e
deg=0
case name of
    'psfA': begin
        deg=22.5
        fact=4
    end
    'psfB':begin
        deg=22.5
        fact=4
    end
    'psfC': begin
        deg=22.5
        fact=4
    end
    'psfD': begin
        fact=1
    end
    'psfE': begin
        fact=1
    end
    'psfF': begin
        fact=1
    end
    'psfG': begin
        fact=1
    end
    'psfH': begin
        deg=-0.5*atan(e[1],e[0])*!radeg+2.70115
        fact=1
    end
    'psfI': begin
        deg=45-0.5*atan(e[1],e[0])*!radeg+2.70115
        fact=1
    end
    'psfJ': begin
        deg=90-0.5*atan(e[1],e[0])*!radeg+2.70115
        fact=1
    end
    'psfK': begin
        deg=135-0.5*atan(e[1],e[0])*!radeg+2.70115
        fact=1
    end
    'psfL': fact=1
endcase
fact=1

print,'rotating by',deg
if deg ne 0 then shapelets_rotate,decomp,deg
if name eq 'psfL' then shapelets_circularise,decomp

shapelets_recomp,decomp,recomp
fits_write,name+'_recomp2.fits',recomp
message,'Recomped PSF moments after recentering & rotation:',/info
two_d_moments,name+'_recomp2.fits',$
              weight='circular gaussian',sigma=sigma,$
              theta_px=[psf_scale,pixel_scale],moms=moms,$
              detect_thresh=detect_thresh,/norrg
cent=[moms.Ix,moms.Iy]/moms.scale
print,'cent=',cent
print,'shapelets_cent-cent=',shapelets_centroid(decomp)-decomp.x

decomp.n_pixels=fact*round(decomp.n_pixels*psf_scale/pixel_scale)
decomp.x=fix(fact*decomp.x*psf_scale/pixel_scale)+0.5
decomp.beta=decomp.beta*psf_scale/pixel_scale
decomp.coeffs=decomp.coeffs/shapelets_flux(decomp)

print,'n_pixels=',decomp.n_pixels
;shapelets_recentre,decomp

shapelets_recomp,decomp,recomp
fits_write,name+'_recomp.fits',recomp
message,'Recomped PSF moments after rescaling:',/info
two_d_moments,name+'_recomp.fits',$
              weight='circular gaussian',sigma=sigma,$
              theta_px=[pixel_scale,pixel_scale],moms=moms,$
              detect_thresh=detect_thresh,/norrg,cent_err=1e-10
print,'n_pixels=',(size(recomp))[[1,2]]
print,'n_pixels/sigma=',(size(recomp))[[1,2]]/sigma*pixel_scale
cent=[moms.Ix,moms.Iy]/moms.scale
print,'cent=',cent
print,'shapelets_cent-cent=',shapelets_centroid(decomp)-decomp.x

window,0
shapelets_plot_image,pstamp.image,/clog
window,1
shapelets_recomp,decomp,img
shapelets_plot_image,img,/clog

if keyword_set(dostop) then stop else wait,5

return,decomp

end

pro step3_prep_psfs,path=path,dostop=dostop

compile_opt idl2

if not keyword_set(path) then begin 
    path='.'
    message,"Assuming path to be "+path,/info
endif else begin
; Strip any trailing foward-slash.
    last_char=strmid(path,strlen(path)-1,strlen(path))
    if last_char eq '/' then begin
        path=strmid(path,0,strlen(path)-1)
    endif
endelse
message,"Path="+path,/info

restore,path+'/STEP3_PSFs_rjm.sav',/verbose

psfA=step3_get_psf_decomp('psfA','psfA_smooth',path=path,dostop=dostop)
psfB=step3_get_psf_decomp('psfB','psfB_smooth',path=path,dostop=dostop)
psfC=step3_get_psf_decomp('psfC','psfC_smooth',path=path,dostop=dostop)
psfD=step3_get_psf_decomp('psfD','TinyTim_f1_postage',path=path,dostop=dostop)
psfE=step3_get_psf_decomp('psfE','TinyTim_f1_postage',path=path,dostop=dostop)
psfF=step3_get_psf_decomp('psfF','TinyTim_f1_postage',path=path,dostop=dostop)
psfG=step3_get_psf_decomp('psfG','TinyTim_f1_postage',path=path,dostop=dostop)
psfH=step3_get_psf_decomp('psfH','TinyTim_f1_postage',path=path,dostop=dostop)
psfI=step3_get_psf_decomp('psfI','TinyTim_f1_postage',path=path,dostop=dostop)
psfJ=step3_get_psf_decomp('psfJ','TinyTim_f1_postage',path=path,dostop=dostop)
psfK=step3_get_psf_decomp('psfK','TinyTim_f1_postage',path=path,dostop=dostop)
psfL=step3_get_psf_decomp('psfL','TinyTim_f1_postage',path=path,dostop=dostop)

save,file=path+"/STEP3_PSFs.sav",psfA,psfB,psfC,$
     psfD,psfE,psfF,psfG,psfH,psfI,psfJ,psfK,psfL,psfM

end
