pro make_gauss_bigger,fwhm=fwhm,bin=bin

;file='~/dunePSF.fits'
;file='~/Desktop/Dune-PSF2.fits'
;file='~/Desktop/Dune-PSF3.fits'
;file='~/dunePSF-Gauss.fits'


pscale=0.115

im=mrdfits(file,0,hdr)

if n_elements(fwhm) eq 0 then fwhm=3.85
if n_elements(bin) eq 0 then bin=0

nxs=25
make_gaussian,g,size=[nxs,nxs],fwhm=fwhm
g=g/total(g)

;im2=convol(im,g,/edge_tr)
im2=im

if 0 then begin
    sxaddpar,hdr,'PSCALE',0.115/4.0
    writefits,'~/dunePSF.fits',im2,hdr
endif

ss=size(im,/dim)
nx=ss[0]
ny=ss[1]

cenx=nx/2
ceny=ny/2
buf=15

;rebin?

im3=im2[cenx-buf:cenx+buf+1,ceny-buf:ceny+buf+1]

ss=size(im3,/dim)
nx3=ss[0]
ny3=ss[1]

if bin then begin
    im3=rebin(im3,nx3/4,ny3/4)
    ss=size(im3,/dim)
    nx3=ss[0]
    ny3=ss[1]
    pscale=pscale*4.0
endif

yfit=gauss2dfit(im3,arr)

tvim2,im3
wait,1

plot,im3[nx3/2,*]
oplot,yfit[nx3/2,*],color=!red

oplot,im3[*,ny3/2],psym=-7
oplot,yfit[*,ny3/2],color=!green,psym=-7



xx=arr[2]
yy=arr[3]
rr=sqrt(0.5*(xx^2+yy^2))

l=lindgen(97*97)
x=float(l mod 97)-97/2
y=float(l/97)-97/2
r2=x^2+y^2
u=(r2/rr^2)
mask=u lt 20.0
imGG=reform(mask*exp(-0.5*u*mask),97,97)
imGG=imGG/total(imGG)

if 0 then begin
    sxaddpar,hdr,'PSCALE',0.115/4.0
    writefits,'~/dunePSF-Gauss.fits',imGG,hdr
endif

;print,xx,yy,rr
a=[xx,yy,rr]

fac=2.0*sqrt(2*alog(2)) 

b=a*fac
print,'Pixels ',b
print,'Pixels/4 ',b/4.0
print,'Arcsec ',b/4.0*pscale


return
end
