#!/usr/local/bin/perl

use strict;
use warnings;
use Simgen::SuperGlobal;
use Simgen::Global;
use Simgen::IO;
use Simgen::Init;
use Simgen::Util;

if ( scalar @ARGV != 1 ) {
    die "ERROR\n";
}

my $run_arg = $ARGV[0];

# Initialize variables from global libraries.
my %t = Simgen::Init::Tweaks;
my %paramFiles = Simgen::Init::ParamFiles( \%t );
my %software = Simgen::Init::Software( \%t );
my @pixel_scale = @Simgen::Global::pixel_scale;
my @n_pixels = Simgen::Init::N_Pixels( \@pixel_scale );
my @gamma = @Simgen::Global::gamma;
my @dither = @Simgen::Global::dither;

my $run_count = 0;
for my $pixel_scale ( @pixel_scale ) {
    my $stellar = 1;
    for my $gamma ( @gamma ) {
	if ( $stellar ) {
	    # Stellar field.  The gamma_i commandline inputs don't
	    # matter here.
	    for my $dither ( @dither ) {
		if ( Simgen::Util::rootFilename($run_count,4) eq $run_arg ) {
		    print "stellar = \t$stellar\n";
		    print "pixel_scale = \t$pixel_scale\n";
		    print "gamma = \tNA\n";
		    print "dither = \t@$dither\n";
		    exit 0;
		}
		$run_count++;
	    }
	    $stellar = 0;
	}
	# Galaxy field.
	for my $dither ( @dither ) {
	    if ( Simgen::Util::rootFilename($run_count,4) eq $run_arg ) {
		print "stellar = \t$stellar\n";
		print "pixel_scale = \t$pixel_scale\n";
		print "gamma = \t@$gamma\n";
		print "dither = \t@$dither\n";
		exit 0;
	    }
	    $run_count++;
	}
    }
}

die "No match.\n";
