#!/usr/local/bin/perl

use strict;
use warnings;
use Simgen::SuperGlobal;
use Simgen::Global;
use Simgen::IO;
use Simgen::Init;
use Simgen::Util;

if ( scalar @ARGV != 7 ) {
    die "ERROR";
}

my $psf_arg = $ARGV[0];
my $stellar_arg = $ARGV[1];
my $pixel_scale_arg = $ARGV[2];
my @gamma_arg = @ARGV[3,4];
my @dither_arg = @ARGV[5,6];

#  print "psf_arg=\t$psf_arg\n";
#  print "stellar_arg=\t$stellar_arg\n";
#  print "pixel_scale_arg=\t$pixel_scale_arg\n";
#  print "gamma_arg=\t@gamma_arg\n";
#  print "dither_arg=\t@dither_arg\n";

# Initialize variables from global libraries.
my %t = Simgen::Init::Tweaks;
my %paramFiles = Simgen::Init::ParamFiles( \%t );
my %software = Simgen::Init::Software( \%t );
my @pixel_scale = @Simgen::Global::pixel_scale;
my @n_pixels = Simgen::Init::N_Pixels( \@pixel_scale );
my @gamma = @Simgen::Global::gamma;
my @dither = @Simgen::Global::dither;

my $run_count = 0;
for my $pixel_scale ( @pixel_scale ) {
    my $stellar = 1;
    for my $gamma ( @gamma ) {
	if ( $stellar ) {
	    # Stellar field.  The gamma_i commandline inputs don't
	    # matter here.
	    for my $dither ( @dither ) {
		if ( $pixel_scale == $pixel_scale_arg &&
		     $$dither[0] == $dither_arg[0] &&
		     $$dither[1] == $dither_arg[1] &&
		     $stellar == $stellar_arg ) {
		    print Simgen::Util::rootFilename($run_count,4),"\n";
		}
		$run_count++;
	    }
	    $stellar = 0;
	}
	# Galaxy field.
	for my $dither ( @dither ) {
	    if ( $pixel_scale == $pixel_scale_arg && 
		 $$gamma[0] == $gamma_arg[0] &&
		 $$gamma[1] == $gamma_arg[1] &&
		 $$dither[0] == $dither_arg[0] &&
		 $$dither[1] == $dither_arg[1] &&
		 $stellar == $stellar_arg ) {
		print Simgen::Util::rootFilename($run_count,4),"\n";
	    }
	    $run_count++;
	}
    }
}
