#!/usr/bin/perl

use strict;
die "Please set the SIMGEN environment variable" unless $ENV{SIMGEN};
use lib "$ENV{SIMGEN}";
use Simgen::Global;
use Simgen::Locale;

if ( Simgen::Global::Institute eq "Caltech" ) {
    for my $index ( 1 .. 7 ) {
	
	print "\tkishar$index\n";
	
	system "ssh -x kishar$index 'killall -v simgen4.pl'";
	system "ssh -x kishar$index 'killall -v rrg_get_shear'";
	system "ssh -x kishar$index 'killall -v rrg_get_psf'";
	system "ssh -x kishar$index 'killall -v generate_simage'";
	system "ssh -x kishar$index 'killall -v idl'";
	system "ssh -x kishar$index 'killall sshd'";
    }
    
    system "killall simgen.pl";
    system "killall simgen2.pl";
    system "killall simsub.pl";
#system "killall ssh";
} elsif ( Simgen::Global::Institute eq "PDSF" ) {
    my $killCmd = "bkill";
    $killCmd = "qdel" if ( Simgen::Locale::Cluster eq "SGE" );
    for ( my $i=0; $i < 3; $i++ ) {
	print "$killCmd -u fwh\n";
	system "$killCmd -u fwh";
    }
} else {
    die "Killed nothing\n";
}
