#!/usr/local/bin/perl

use strict;
use warnings;
use Simgen::SuperGlobal;
use Simgen::Global;
use Simgen::IO;
use Simgen::Init;
use Simgen::Util;
use Simgen::Engine;

my %t = Simgen::Init::Tweaks;
my %paramFiles = Simgen::Init::ParamFiles( \%t );
my %software = Simgen::Init::Software( \%t );
my @globalTick = Simgen::Util::tick("simgen global stopwatch");
#my @pixel_scale = @Simgen::Global::pixel_scale;
my @pixel_scale = ( 0.04 );
my @n_pixels = Simgen::Init::N_Pixels( \@pixel_scale );
#my @gamma = ( [ 0.0, 0.0 ] );
my @gamma = @Simgen::Global::gamma;
my @dither = @Simgen::Global::dither;

# Make runtime scripts.
my $count = 0;
my $pxCount = 0;
for my $pixel_scale ( @pixel_scale ) {

    my $needStellar = true;

    for my $gamma ( @gamma ) {
	
	for my $dither ( @dither ) {
	    
	    $t{pixel_scale} = $pixel_scale;
	    $t{n_pixels} = $n_pixels[ $pxCount ];
	    $t{x_dither} = $dither->[0];
	    $t{y_dither} = $dither->[1];
	    $t{random_seed} = $t{noise_seed} = $count;
	    $t{data_in_home} = $t{data_home} . "/in";
	    my $outDirSuffix = "";
	    $outDirSuffix = "_const_no.2" if $t{const_psf_size};
	    $outDirSuffix = "" if !$t{const_psf_size};
	    $t{data_out_home} = "$t{data_home}/out/$t{output_file}$outDirSuffix";
	    
	    if ( $needStellar ) { 
		
		$t{input_gamma_1} = 0;
		$t{input_gamma_2} = 0;
		$t{n_star} = 372;
		$t{n_gal} = 0;
		$t{stellar} = true;

		$t{'run'} = "r$count";
		my $suffix = $count;
		Simgen::IO::MakeRTScript( "shapelets", "simage", \%software, \%paramFiles, \%t, $suffix );
#		Simgen::IO::MakeSex( "shapelets", \%paramFiles, \%t, $suffix );

		$needStellar = false;
		$count++;
	    }

	    $t{input_gamma_1} = $gamma->[0];
	    $t{input_gamma_2} = $gamma->[1];
	    $t{n_star} = 0;
	    $t{n_gal} = 6000;
	    $t{stellar} = false;

	    $t{'run'} = "r$count";
	    my $suffix = $count;
	    Simgen::IO::MakeRTScript( "shapelets", "simage", \%software, \%paramFiles, \%t, $suffix );
	    
	    $count++;
	} # End for each dither.
    } # End for each gamma.
    $pxCount++;
} # End for each pixel scale.

# Make IDL runtime binaries.
Simgen::Engine::MakeRT( "shapelets", "simage", \%software );
