pro show_udf_throughput,rats

lamstart=[3748.9565    ,   4737.0988  ,     6999.9447  ,     8343.8182,   8019.0,   13940.0] 
lamend=[4806.2688    ,   7088.8775    ,   8541.4467    ,   10400.0 ,   14019.0   ,  17993.0]

fname=['B','V','i','z','J','H']
cols=[!blue,!green,!red,!purple,!orange,!black]

dir='/Users/djohnsto/acs_trans/trans/'
tfile=dir+'udf_throughputs_lam_bvizjh.txt'

tit='SNAP v. ACS total throughput'
xtit=!csym.lambda

plot,[0,1],[0,1],yr=[0,1],/nodata,xr=[3e3,2e4],/xst,tit=tit,xtit=xtit,charsize=1.5

readcol,tfile,lambda,b,v,i,z,j,h
nfils=n_elements(fname)
n=n_elements(lambda)
tput=fltarr(n,6)
tput[*,0]=b
tput[*,1]=v
tput[*,2]=i
tput[*,3]=z
tput[*,4]=j
tput[*,5]=h


dx=shift(lambda,-1)-lambda
dx=dx[0:n-2]

rats=fltarr(nfils)

tot_trans=rats
tot_trans_snap=rats

for i=0,nfils-1 do begin
    tp=tput[*,i]
    oplot,lambda,tp,color=cols[i]
    sfilter=(lambda gt lamstart[i] and lambda lt lamend[i])*0.9
    oplot,lambda,sfilter,color=cols[i],psym=0,linest=3
    y=0.5*(tp+shift(tp,-1))
    y=y[0:n-2]
    tot_trans[i]=total(dx*y)
    tot_trans_snap[i]=0.9*(lamend[i]-lamstart[i])
    rat=tot_trans_snap[i]/tot_trans[i]
    ratt=round(rat*100)/100.0
    rats[i]=rat
    xx=(lamend[i]+lamstart[i])/2.0-100
    xyouts,xx,0.95,strmid(strcompress(ratt,/rem),0,4),/data,color=cols[i],charsi=1.5
    xyouts,xx,0.6,fname[i],/data,color=cols[i],charsi=2
endfor

print,rats

return
end



