pro simage_filter_zeropoint,lam,filt,area,z,w
;calculate the AB zeropoint of a telescope and filter
;lam - wavelength angstroms
;filt - total throughput
;area - area of telescope in m^2

if n_params() eq 0 then begin
    print,'-syntax filter_zeropoint,lam,filt,area,z,w'
    return
endif


A=area*1e4                      ;converted to cm^2

;calculate the filter "width"

W=int_tabulated(lam,filt/lam)

h=6.626e-27                     ; Planck's constant in erg*sec (cgs units)

;print,'W = ',W

z=2.5*alog10(W*A/h)-48.6
;http://www.stsci.edu/instruments/wfpc2/Wfpc2_hand/HTML/W2_59.html


;stop
return
end


