pro simage_get_filter_zero,tel,filt,str,area=area,plot=plot

if n_params() eq 0 then begin
    print,'-syntax simage_get_filter_zero,tel,filt,str,area=area'
    return
endif

;get_snap_trans,lam,T,num=num
simage_get_filt_trans,tel,filt,lam,T

if keyword_set(plot) then plot,lam,T,psym=-1

;get detecting area in m^2

if n_elements(area) eq 0 then begin
    if tel  eq 'snap' then area= 2.6389378
    if tel  eq 'hst' then area= 4.5239
    if tel eq 'dune' then area=1.13
endif

simage_filter_zeropoint,lam,T,area,z,W

print,'z = ',z
print,'w = ',W

c=3e18                          ;speed of light in A/sec
simage_get_zodi,ll,zz
zod=interpol(zz,ll,lam)
F=int_tabulated(lam,zod*T*lam)/(c*W)
mag_sky=-2.5*alog10(F)-48.6
mag_sigma1=(z+mag_sky)/2.0

print,'F = ', F
print,'mag_sky = ',mag_sky
print,'mag_sigma = ',mag_sigma1,' +1.25*alog10(T) '

str={tel:tel,filt:filt,w:w,z:z,Fsky:F,mag_sky:mag_sky,mag_sigma1:mag_sigma1,area:area}

return
end
