pro simage_get_hst_trans,lam,T,filt=filt
;get the HST ACS transmission curve

;dir='/Users/djohnsto/acs_trans/trans/'
;dir='/Users/davej/data/acs_trans/trans/'

dir=simage_shapelets_paths(1,/silent)+"acs_trans/"

isJH=0
if strupcase(filt) eq 'J' or strupcase(filt) eq 'H' then begin
    ;do these differenctly since they are not ACS
    ;they are precomputed
    tfile=dir+'udf_throughputs_lam_jh.fits'
    ;readcol,tfile,lam,b,v,i,z,j,h
    str=mrdfits(tfile,1,/silent)
    lam=str.lam
    j=str.Tj
    h=str.Th
    ;print,'Nicmos filter ',filt
    isJH=1
endif

lam_min=2.5e3
lam_max=2.1e4
lnum=10000
lambda=(lam_max-lam_min)*findgen(lnum)/(lnum-1)+lam_min

if isJH then begin
    if strupcase(filt) eq 'J' then trans=j
    if strupcase(filt) eq 'H' then trans=h

    T=interpol(trans,lam,lambda)
    lam=lambda
    return
endif

file=dir+'acs_wfc_ebe_win12f_005_syn.fits'
outfile=dir+'throughput_lam_trans_BViz.fits'
d=mrdfits(file,1,hdr,/silent)
lam1=d.wavelength
t1=d.throughput
tran1=interpol(t1,lam1,lambda)

;mirror

file=dir+'acs_wfc_im123_004_syn.fits'

d=mrdfits(file,1,hdr,/silent)
lam2=d.wavelength
t2=d.throughput
tran2=interpol(t2,lam2,lambda)

;ccd use ccd1 I guess

file=dir+'acs_wfc_ccd1_017_syn.fits'

d=mrdfits(file,1,hdr,/silent)
lam3=d.wavelength
t3=d.throughput
tran3=interpol(t3,lam3,lambda)

;the HST OTA

file=dir+'hst_ota_006.fits'

d=mrdfits(file,1,hdr,/silent)
lam4=d.wavelength
t4=d.throughput
tran4=interpol(t4,lam4,lambda)

trans=tran1*tran2*tran3*tran4
;this is the instrument sensitivity, prior to filters

;Now get the filters

all_files=[$
'acs_f435w_004_syn.fits',$
'acs_f475w_004_syn.fits',$
'acs_f550m_005_syn.fits',$
'acs_f555w_003_syn.fits',$
'acs_f606w_005_syn.fits',$
'acs_f625w_004_syn.fits',$
'acs_f775w_003_syn.fits',$
'acs_f814w_003_syn.fits',$
'acs_f850lp_004_syn.fits']

all_names=[$
'f435w',$
'f475w',$
'f550m',$
'f555w',$
'f606w',$
'f625w',$
'f775w',$
'f814w',$
'f850lp']

;translate them?
fils=['B','V','I','Z']
tfils=['f435w','f606w','f775w','f850lp']

filter=filt
w=where(fils eq strupcase(filt),nn)
if nn ne 0 then filter=tfils[w]

if strlowcase(filt) eq 'cosmos' then filter='f814w'

filter=filter[0]
w=where(all_names eq filter,nn)

tfile=dir+'udf_throughputs_lam_bvizjh.txt'

if nn eq 0 then begin
    print,'Error - filter ',filt,' not in list:'
    print,[all_names,fils,['cosmos']]
    
    lam=-1
    T=-1
    return
endif


fil_file=dir+all_files[w[0]]

d=mrdfits(fil_file,1,hdr,/silent)
lam=d.wavelength
t=d.throughput
tp=interpol(t,lam,lambda)
tptot=tp*trans

;rename these

lam=lambda
T=tptot


return
end
