pro simage_convert_lbl_psf,ascii_file,fits_file,log=log
;convert an LBL psf file to a fits image file

read_lbl_psf,ascii_file,psf,pscale

s=size(psf,/dimen)
nx=s[0]
mkhdr,hdr,4,[nx,nx]
;4 for floating point

ofile=file_basename(ascii_file)

fxaddpar,hdr,'PSCALE',pscale,'Pixel Scale arcsec per pix' 
fxaddpar,hdr,'AFILE',ofile,'Original ascii file' 


if keyword_set(log) then begin
    ;convert to log scaling
    psf=alog10(psf)
    fxaddpar,hdr,'UNITS','dB'
endif else begin
    fxaddpar,hdr,'UNITS','flux'
endelse

writefits,fits_file,psf,hdr

return
end
