pro simage_get_sholl_psf,diam,debug=debug

dir='/Users/djohnsto/data/PSF/Sholl_LBL/PSF/fits/'
pixsize=0.1
diff_length=4.0
const_psf_size=0

si=[1500,1800,2000,2200]
w=where(si eq diam,nw)
dd=strcompress(si[w],/rem)+'mm'
files=dir+['rhodes_09.fits','rhodes_10.fits','rhodes_11.fits','rhodes_12.fits']

if nw eq 0 then begin
    print,'Diam mist be 1500, 1800, 2000 or 2200'
    return
endif

file=files[w]
file=file[0]

print,file

pbig=mrdfits(file,0,hdr)
ss=size(pbig,/dim)
nxb=ss[0]

pscale=sxpar(hdr,'pscale')
ps_snap=0.1
psize_mic=10.0
gx=31L
;print,hdr
print,'pscale ',pscale


dlen=(ps_snap/pscale)*diff_length/psize_mic
dl2=double(dlen)^2
;make a gaussian
l=lindgen(gx^2) & x=(l mod gx)-gx/2 & y=(l /gx)-gx/2 & rr=x^2+y^2 & g=exp(-0.5d *rr/dl2) & g=reform(g/total(g),gx,gx)


;tvim2,pbig,xst=4,yst=4
;tvim2,g

pbigc=alog10(convol(10.0^pbig,g,/edge_tr))
nx=51

psmc=alog10(congrid(10.0^pbigc,nx,nx))

;tvim2,psmc

buf=10
arr=fltarr(2*nxb+3*buf,nxb+2*buf)
arr[buf:nxb+buf-1,buf:buf+nxb-1]=pbig
arr[nxb+2*buf:2*nxb+2*buf-1,buf:buf+nxb-1]=pbigc

tvim2,arr,xst=4,yst=4,r=[1,7],tit='Optics         W. Diffusion'
x=findgen(nxb)-nxb/2
x=x*pscale
y1=10.0^pbig[nxb/2,*]*1e-6
y2=10.0^pbigc[nxb/2,*]*1e-6

mx=max(y2)
ww=where(y2 ge mx/2.0,nw)

;ww=[ww[0]-1,ww,ww[nw-1]+1]
print,nw
fwhm=x[ww[nw-1]]-x[ww[0]]
print,'fwhm = ',fwhm, 'Arcsec'

fac=2*sqrt(2*alog(2))
gg=gaussfit(x[ww],y2[ww],A,nterms=3)
print,A
fwhmg=fac*A[2]
fwhms=strmid(strcompress(fwhmg,/rem),0,5)
print,'FWHM-g = ',fwhms


plot,x,y1,tit='D = '+dd+'    FWHM = '+fwhms+" Arcsec",xtit='Arcsec',xr=[-0.5,0.5]
oplot,x,y2,color=!red
;oplot,x[ww],y2[ww],color=!blue
;oplot,x[ww],gg,color=!green

if keyword_set(debug) then stop
return
end
