pro simage_make_mag_hist,im,cat,old=old

pscale=0.1

!p.multi=[0,2,4]
!p.multi=0
number=1
cols=[!black,!red,!blue,!magenta]
sncut=10.0
lst=1

rdir='~/data/nersc/LBL_old2/'
r=[0,0.01]

dold=''
if keyword_set(old) then dold='_old'
d=['1500mmTest','1800mmTest','2000mmTest','2200mmTest']
dd=['1500mm','1800mm','2000mm','2200mm']
nd=n_elements(d)

cats=ptrarr(nd)
ims=ptrarr(nd)
for i=0, nd-1 do begin
    dir=rdir+d[i]+dold+'/'
    num=pnum(number,4)
    imfile=dir+'LBL_'+d[i]+'_'+num+'_noisy.fits'
    catfile=dir+'LBL_'+d[i]+'_'+num+'_noisy_sexcat.fits'
    print,'image  ',imfile
    print,'catfile',catfile
    im=mrdfits(imfile,0,hdr)
    ss=size(im,/dim)
    npix=ss[0]*ss[1]
    area=npix*(pscale/60.0)^2
    cat=mrdfits(catfile,1,hdr)
    cats[i]=ptr_new(cat)
    ims[i]=ptr_new(im)
    cat=0
endfor

print,'Area ',area,' square-arcmin'

if 0 then begin
    for i=0, nd-1 do begin
        im=*ims[i]
        cat=*cats[i]
        sig=sigma(im)
        tvim2,im,r=[-sig,3*sig]
        tvcircle,10,cat.x_image-1,cat.y_image-1,/data,color=!yellow
        print,'ok?'
        key=get_kbrd(20)
        if key eq 'q' then goto, DONE
        if key eq 's' then stop
    endfor
endif

if 1 then begin
    tit='Cumulative Galaxy number count density'
    for i=0, nd-1 do begin
        im=*ims[i]
        cat=*cats[i]
        sn=cat.flux_best/cat.fluxerr_best
        w=where(sn gt sncut,nw)
        plothist,cat.mag_best,bin=.1,hx,hy,/noplot
        plothist,cat[w].mag_best,bin=.1,hx2,hy2,/noplot
        tot=total(hy,/cum)
        tot2=total(hy2,/cum)
        den=tot/area
        den2=tot2/area
        if i eq 0 then begin
            plot,hx,den,ylog=0,/yst,tit=tit,xtit='mag_best',ytit='Num / Arcmin^2',xr=[0,5],yr=[10,300],linest=lst
            oplot,hx2,den2
        endif else begin
            oplot,hx,den,color=cols[i],linest=lst
            oplot,hx2,den2,color=cols[i]
        endelse
        
        xyouts,-2.5,80.0/(1.6^i),dd[i],color=cols[i],charsize=2
        print,'ok?'
        key=get_kbrd(20)
        if key eq 'q' then goto, DONE
        if key eq 's' then stop
    endfor
endif

if 0 then begin
    for i=nd-1, 0, -1 do begin
        print,i
        im=*ims[i]
        cat=*cats[i]
        ncat=n_elements(cat)
        if i eq 3 then plot,cat.fwhm_image,cat.mag_best,psym=1,xr=[0,15],color=cols[i] else oplot,cat.fwhm_image,cat.mag_best,psym=1,color=cols[i]
        print,'ok?'
        key=get_kbrd(20)
        if key eq 'q' then goto, DONE
        if key eq 's' then stop
    endfor
endif



DONE:
print,'Deleting pointers'
for i=0, nd-1 do begin
    ptr_free,cats[i]
    ptr_free,ims[i]
endfor


return
end
