pro simage_moms_stars_gals,diam,mcat,mscat,morenoise=morenoise

rdir='/Users/djohnsto/data/nersc/LBL/'
dd=strcompress(diam,/rem)+'mm'
dir=rdir+dd+'/'
fnum=5
z=22.0
mfac=1.7
sncut=12.0
ccut=1.5
chicut=6.0
pscale=0.1
afac=1.0                        ;fudge factor to correct area

nn='_noisy'
if keyword_set(morenoise) then nn='_noisier'

pref='LBL_'+dd+'_'+pnum(fnum,4)+nn
prefs='LBL_'+dd+'_'+pnum(0,4)+nn

imfile=dir+pref+'.fits'
catfile=dir+pref+'_sexy.fits'
mcatfile=dir+pref+'_sexy_moms.fits'

imfiles=dir+prefs+'.fits'
catfiles=dir+prefs+'_sexy.fits'
mcatfiles=dir+prefs+'_sexy_moms.fits'

im=mrdfits(imfile,0,hdr)
ims=mrdfits(imfiles)

ss=size(im,/dim)
npix=ss[0]*ss[1]
area=npix*(pscale/60.0)^2
area=area*afac
print,area, ' square-AM'

cat=mrdfits(catfile,1)
cats=mrdfits(catfiles,1)

print,imfile
print,imfiles
print,catfile
print,catfiles


if file_test(mcatfile) eq 0 and file_test(mcatfiles) eq 0 then begin
    print,'Running photo_2dt'
    add_pmoms,im,cat,mcat
    add_pmoms,ims,cats,mcats
    
    mwrfits,mcat,mcatfile,/create
    mwrfits,mcats,mcatfiles,/create
endif else begin
    print,'reading files'
    mcat=mrdfits(mcatfile,1)
    mcats=mrdfits(mcatfiles,1)
endelse

d=sqrt((mcat.ixx+mcat.iyy)/2.0)
m=z+mcat.mag_best

ds=sqrt((mcats.ixx+mcats.iyy)/2.0)
ms=z+mcats.mag_best

;mstar=median(rs)
;mcut=mfac*mstar
coeff=[median(mcats.ixx),median(mcats.iyy)]
dcut = 1.2 * sqrt( (coeff[0] + coeff[1])/2. + 0.4 )

n=n_elements(mcat)

w=where(d gt dcut,np)
size_pass=intarr(n)
size_pass[w]=1
frac=np/float(n)
print,'Frac passing size cut',frac

sn=mcat.flux_best/mcat.fluxerr_best
w=where(sn gt sncut,np)
sn_pass=intarr(n)
sn_pass[w]=1
frac=np/float(n)
print,'Frac passing SN cut',frac

dis=sqrt((mcat.x_image-1-mcat.xc)^2 + (mcat.y_image-1-mcat.yc)^2)
w=where(dis lt ccut,np)
cen_pass=intarr(n)
cen_pass[w]=1
frac=np/float(n)
print,'Frac passing centroid cut',frac

chi=mcat.chi
w=where(chi lt chicut,np)
chi_pass=intarr(n)
chi_pass[w]=1
frac=np/float(n)
print,'Frac passing Chi cut',frac

mom_pass=cen_pass*chi_pass
ww=where(mom_pass,np)
frac=np/float(n)
print,'Frac passing Moments=GOOD',frac

wbad1=where(sn_pass eq 0,nbad)
print,nbad
wbad2=where(mom_pass eq 0,nbad)
print,nbad

wgood=where(sn_pass and size_pass and mom_pass,ngood)

print,'Ngood = ',ngood
fracgood=ngood/float(n)
print,'Frac_good = ',fracgood

den=Ngood/area
tit='D = '+dd+'  Den = '+strmid(strcompress(den,/rem),0,5)+ ' FracPass = '+strmid(strcompress(fracgood,/rem),0,4)

plot,d,m,xr=[0,6],yr=[26,18],psym=3,tit=tit,xtit='Size',ytit='Mag',/yst
oplot,ds,ms,psym=1,color=!blue
;oplot,[1,1]*mstar,[0,100],linest=2,color=!orange
oplot,[1,1]*dcut,[0,100],linest=3,color=!orange
oplot,d[wbad1],m[wbad1],psym=3,color=!red
oplot,d[wbad2],m[wbad2],psym=3,color=!magenta
oplot,d[wgood],m[wgood],psym=3,color=!green


return
end
