pro simage_sholl_psf_size,fwhm

fwhm=fltarr(4,4)

pr=1
dir='/Users/djohnsto/data/PSF/Sholl_LBL/PSF/fits/'

pscale=0.0082505922             ;arcsec per pixel

f=findfile(dir+'rhodes_??.fits',count=nf)

print,nf,'  files'
nx=201
;window,0
;!p.multi=[0,4,4]

buf=20
nxx=nx*4+buf*5
im=fltarr(nxx,nxx)

k=0L

diam=['1.5','1.8','2.0','2.2']+'m'
wave=[0.3329,0.4656,0.5984,0.7311] ;microns
wave=long(wave*1e4)

ang=!csym.angstrom

numx=100000L
x=findgen(numx)/(numx-1)
x=x*200-100

xx=findgen(201)-100

for i=0, 3 do begin
    for j=0, 3 do begin
        k=4*i+j
        im_ij=mrdfits(f[k],0)
        print,f[k]
        if i eq 1 and j eq 3 then ims=im_ij ;plot this one
        if keyword_set(pr) then begin
            ;tvim2,im_ij
            sl=im_ij[*,100]
            plot,xx,10.0^sl,psym=-7,xr=[-25,25],/xst,/yno
            y=interpol(sl,xx,x,/spline)
            oplot,x,10.0^y,psym=3,color=!magenta
            dy=alog10(2.0)
            msl=max(sl)
            oplot,[-100,100],[1,1]*10.0^(msl),color=!red
            oplot,[-100,100],[1,1]*10.0^(msl)/2.0,color=!red
            print,'max ',msl
            w=where(x gt -10 and x lt 10 and y gt (msl-dy),nn)
            oplot,x[w],10.0^y[w],color=!green,psym=0
            print,nn,' points'
            fwhm[j,i]=(x[w[nn-1]]-x[w[0]])*pscale
            print,'FWHM',fwhm[j,i]
            print,'i = ',i,' j = ',j
            print,'OK?'
            key=get_kbrd(20)
            ;key=''
            if key eq 'q' then return
        endif
        im[buf*(j+1)+nx*j:buf*(j+1)+nx*(j+1)-1,buf*(i+1)+nx*i:buf*(i+1)+nx*(i+1)-1]=im_ij
    endfor
endfor

return

xtit='Arcseconds'
ytit='Arcseconds'
xr=[-100,100]*pscale
yr=[-100,100]*pscale

if keyword_set(mos) then begin
    
    xg=-45+findgen(4)/3.0*878
    tvim2,-im^2,xst=4,yst=4,/noinv
    
    for i=0, 3 do begin
        ;print,'click x,y for y titles'
        ;cursor,x,y,/data,/down
        xyouts,xg[i]-40,-250,strcompress(diam[i],/rem),/data
        xyouts,-395,xg[i],strcompress(wave[i],/rem)+' '+ang,/data
    endfor
    
endif else begin
    tvim2,-ims^2,xst=1,yst=1,xr=xr,yr=yr,xtit=xtit,ytit=ytit
endelse
    
if keyword_set(debug) then stop

return
end
