pro simage_test_recomp,debug=debug

pixsize=0.008

pfile='/Volumes/Data/PSF/Sholl_LBL/PSF/fits/rhodes_10.fits'

                                ; Print intention to screen
    message,'Reading in whatever PSF is in .../simgen_data/in/PSF/thispsf/psf.fits',/info,noprint=silent
                                ;This should have odd number of pixels
                                ;and be centered on long(nx)/2 and
                                ;have PSCALE in hdr
        ;also they should be in decibels, so exponentiate

                                ; Read in Jason`s SNAP PSF and
                                ; decompose it into shapelets
        ; This has arcsec/pixel as PSCALE in hdr
    ;pfile=shapelets_paths(1,silent=silent)+'PSF/thispsf/psf.fits'
    psf=10.0^mrdfits(pfile,0,hdr)
    pscale=sxpar(hdr,'PSCALE')
    ss=size(psf,/dim)
    if ss[0] ne ss[1] then begin
        message, "PSF in ",pfile," must be square", /info
        stop    ;       don't let this happen
    endif
    npix=ss[0]
    if (npix/2)*2 eq npix then begin
        ;don't let this happen either
        message, "PSF in ",pfile," must have odd number of pixels", /info
        stop
    endif
    ;psf=psf[*,*];      trim?
    x0 = float([ npix/2 , npix/2])

    if not keyword_set(n_max) then n_max=20
    w=10.0            ; Check that this works well enough
    npix_new=51               ;The new PSF size, odd number
    simage_shapelets_decomp,psf,w,n_max,decomp,recomp,x0=x0,/silent
    decomp.beta=decomp.beta*(pscale/pixsize) ;
    decomp.n_pixels=[npix_new,npix_new]     ;  Image file was oversampled
    decomp.x=[1.0,1.0]*(long(npix_new)/2)        ;

                                ; Add in effect of charge diffusion to
                                ; neighbouring pixels
    if not keyword_set(diff_length) then diff_length = 4.0
    simage_shapelets_read_psf,ch_diff,diff_length*2.3548*0.10,/silent
    decomp=simage_shapelets_convolve(decomp,ch_diff,gamma=10.0,n_max_g=n_max)

                                ; Renormalise so that convolution
                                ; conserves flux
    simage_shapelets_recomp,decomp,recomp
    weight=total(recomp)
    decomp.coeffs(*)=decomp.coeffs(*)/weight
                                ;recomp=recomp/weight
    decomp.name='thispsf'

simage_shapelets_recomp,decomp,recomp

if keyword_set(debug) then stop

return
end
